#pragma once
#include "ResizableLib/ResizableDialog.h"
#include "AntiLeechListCtrl.h"
#include "HypertextCtrl.h"

class CPPgAntiLeech : public CResizableDialog
{
	DECLARE_DYNAMIC(CPPgAntiLeech)

public:
	CPPgAntiLeech();									// standard constructor
	virtual ~CPPgAntiLeech();

	// Dialog Data
	enum { IDD = IDD_PPG_ANTILEECH };

	void    UpdateAntiLeecherList(const CString& m_sURL = _T(""));
	void Localize(void);

protected:	
	bool bCreated;
	CHyperTextCtrl m_wndContact;
	CAntiLeechListCtrl m_lAntiLeech;

	void LoadSettings(void);

	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
	afx_msg void OnDestroy();
	afx_msg void OnSettingsChange()					{ PreSetModified(); }
	afx_msg void OnApplyBtn()						{ OnApply(); }
	afx_msg	void OnUpdateButton(); 
	afx_msg void OnLvnItemchangedAntileechList(NMHDR *pNMHDR, LRESULT *pResult);
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	bool	m_bChanged;
	bool	IsModified() const							{return m_bChanged;}
	void	PreSetModified(const bool& bChanged = true)	{m_bChanged = bChanged; /*SetModified(bChanged)*/;}	
//>>> [ionix] - ionixguide
protected:
	afx_msg void OnHelp();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
//<<< [ionix] - ionixguide
};

//>>> [ionix] - Auto Update AntiLeechlist
class CAutoUpdateAL : public CWinThread
{
	DECLARE_DYNCREATE(CAutoUpdateAL)

public:
	CAutoUpdateAL();
	~CAutoUpdateAL();
	virtual BOOL InitInstance();
	virtual int Run();
};
//<<< [ionix] - Auto Update AntiLeechlist