//////////////////////////////////////////////////////////////////////////
//Please note!
//
//This file contains most code parts from Phoenix - ThX to its modders!
//
//////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "SelNAFCDlg.h"
#include "emule.h"
#include "NAFC.h"
#include "otherfunctions.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CSelNAFCDlg, CDialog)

CSelNAFCDlg::CSelNAFCDlg(CWnd* pWnd)
	: CDialog(CSelNAFCDlg::IDD, pWnd)
{
	selection = -1;
	m_icnWnd = NULL;
}

CSelNAFCDlg::~CSelNAFCDlg()
{
	if (m_icnWnd)
		VERIFY( DestroyIcon(m_icnWnd) );
}

void CSelNAFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SELNAFCLIST, m_nafcBox);
	DDX_Control(pDX, IDC_NAFC_ACCEPT, m_nafcAccept);
	DDX_Control(pDX, IDC_NAFC_CANCEL, m_nafcCancel);
	DDX_Control(pDX, IDC_DYNAMICNAFC, m_dynamicNAFC);
}

BEGIN_MESSAGE_MAP(CSelNAFCDlg, CDialog)
	ON_BN_CLICKED(IDC_NAFC_ACCEPT, OnAcceptClick)
	ON_BN_CLICKED(IDC_NAFC_CANCEL, OnCancelClick)
END_MESSAGE_MAP()

BOOL CSelNAFCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	InitWindowStyles(this);

	//SetWindowText(GetResString(IDS_NETWORKSELECTION));
	//SetIcon(m_icnWnd = theApp.LoadIcon(_T("PHOENIX")), FALSE);

	//m_dynamicNAFC.SetWindowText(GetResString(IDS_DINAMICNAFC));
	m_dynamicNAFC.SetCheck(thePrefs.GetDynamicNAFC());

	m_nafcBox.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	m_nafcBox.InsertColumn(0, GetResString(IDS_DESCRIPTION), LVCFMT_LEFT, 200, -1); 
	m_nafcBox.InsertColumn(1, _T("Index"), LVCFMT_LEFT, 60, -1); 
	m_nafcBox.InsertColumn(2, GetResString(IDS_TYPE), LVCFMT_LEFT, 40, 1); 
	m_nafcBox.InsertColumn(3, _T("MTU"), LVCFMT_LEFT, 40, 1); 
	m_nafcBox.InsertColumn(4, _T("IP"), LVCFMT_LEFT, 100, 1);

	m_nafcBox.DeleteAllItems();
	InitializeTable();

	return TRUE;
}

void CSelNAFCDlg::InitializeTable()
{
	DWORD numEntries = theApp.pNAFC->NafcNumber;
	for(DWORD i = 0; i < numEntries; i++)
	{
		CString tmp;
		m_nafcBox.InsertItem(LVIF_TEXT, i, theApp.pNAFC->m_NAFCInfo[i].description, 0, 0, 1, NULL);
		tmp.Format(_T("%i"), theApp.pNAFC->m_NAFCInfo[i].index);
		m_nafcBox.SetItemText(i, 1, tmp);
		tmp.Format(_T("%i"), theApp.pNAFC->m_NAFCInfo[i].type);
		m_nafcBox.SetItemText(i, 2, tmp);
		tmp.Format(_T("%i"), theApp.pNAFC->m_NAFCInfo[i].mtu);
		m_nafcBox.SetItemText(i, 3, tmp);
		m_nafcBox.SetItemText(i, 4, ipstr(theApp.pNAFC->m_NAFCInfo[i].ip));		

		//TODO! WHY WON'T THIS WORK???
		if (theApp.pNAFC->m_NAFCInfo[i].index == thePrefs.GetNAFCSelection())
		{
			m_nafcBox.SetItemState(i, LVIS_GLOW | LVIS_SELECTED | LVIS_FOCUSED, LVIS_GLOW | LVIS_SELECTED | LVIS_FOCUSED);
			m_nafcBox.SetSelectionMark(i);   // display selection mark correctly! 
		}
	}	
}

void CSelNAFCDlg::OnAcceptClick()
{	
	int iSel = m_nafcBox.GetNextItem(-1, LVIS_SELECTED | LVIS_FOCUSED);
	if (iSel != -1)
	{
		POSITION pos = m_nafcBox.GetFirstSelectedItemPosition(); 
		selection = m_nafcBox.GetNextSelectedItem(pos); 		
	}

	thePrefs.SetDynamicNAFC(m_dynamicNAFC.GetCheck() == BST_CHECKED);

	CDialog::OnOK();
}

void CSelNAFCDlg::OnCancelClick()
{
	CDialog::OnCancel();
}