// PPgIonixConnect.cpp : implementation file
#include "stdafx.h"
#include "emule.h"
#include "PPgIonixConnect.h"
#include "OtherFunctions.h"
#include "Preferences.h"
#include "UserMsgs.h"
#ifdef SPOOKY
#include "sockets.h"
#endif
#include "UploadBandwidthThrottler.h" // Pawcio: BC
#include "DownloadBandwidthThrottler.h" // Pawcio: BC Download
//#include "./NAFC/NAFC.h" //>>> WiZaRd::NAFC

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

// CPPgIonixConnect dialog
IMPLEMENT_DYNAMIC(CPPgIonixConnect, CPropertyPage)
CPPgIonixConnect::CPPgIonixConnect()
	: CPropertyPage(CPPgIonixConnect::IDD)
	, m_ctrlTreeOptions(theApp.m_iDfltImageListColorFlags)
{
	m_bInitializedTreeOpts = false;

	m_htiTimeUp = NULL; //Pawcio: BC
	m_htiTimeDown = NULL; //Pawcio: BC Download
	m_iTimeUp = 10; // Pawcio: BC
	m_iTimeDown = 10; // Pawcio: BC Download
	m_bEnableACC = false; //Obelix
	m_htiEnableACC = NULL; //Obelix

//>>> [ionix] - Pawcio: BC
	m_bZZRatio = false;
	m_bMinimizeOpenedSlots = false;
	m_bCumulateBandwidth = false;
	m_bBadwulfsUpload = false;
	m_bManageConn = false;
	m_bIncludeOH = false;
	m_bConnOH = false;
	m_bIncludeTCPAck = false;
	m_htiSlotGroup = NULL;
	m_htiZZRatio = NULL;
	m_htiMinimizeOpenedSlots = NULL;
	m_htiCumulateBandwidth = NULL;
	m_htiBadwulfsUpload = NULL;
	m_htiPawcioAdvGroup = NULL;
	m_htiManageConn = NULL;
	m_htiIncludeOH = NULL;
	m_htiConnOH = NULL;
	m_htiIncludeTCPAck = NULL;
//<<< [ionix] - Pawcio: BC

	//>>> [ionix] - Max ClientUploadrate
	m_htiMaxClientDatarate = NULL;
	m_uMaxClientDatarate = 0;
	//<<< [ionix] - Max ClientUploadrate

//>>> [ionix] - Deadlist optional
	m_htiIsUseDeadlist = NULL;
	m_bIsUseDeadlist = 0;
//<<< [ionix] - Deadlist optional

	//>>> WiZaRd::NAFC
	/*
	//m_bNAFCAutoLimit = false;
	m_bUseNAFC = false;
	m_bGiveNAFCFullControl = false;
	m_bUseDynamicNAFC = false;
	m_uMinNAFCUpload = 0;
	m_uMinNAFCDownload = 0;
	m_htiNAFCGroup = NULL;
	//m_htiNAFCAutoLimit = NULL;
	m_htiUseNAFC = NULL;
	m_htiGiveNAFCFullControl = NULL;
	m_htiUseDynamicNAFC = NULL;
	m_htiMinNAFCUpload = NULL;
	m_htiMinNAFCDownload = NULL;
	*/
	//<<< WiZaRd::NAFC

	// [MoNKi: -UPnPNAT Support-]
	m_htiUPnPRoot = NULL;
	m_htiUPnP = NULL;
	m_htiUPnPWeb = NULL;
	m_htiUPnPTryRandom = NULL; //new upnp - disabled
	m_bUPnP = false;
	m_bUPnPWeb = false;
	m_bUPnPTryRandom = false; //new upnp - disabled
	// [MoNKi: -UPnPNAT Support-]

	// [MoNKi: -Improved ICS-Firewall support-]
	m_htiICFSupportRoot = NULL;
	m_htiICFSupport = NULL;
	m_htiICFSupportClearAtEnd = NULL;
	m_bICFSupport = false;
	m_bICFSupportClearAtEnd = false;
	// [MoNKi: -Improved ICS-Firewall support-]

	// [MoNKi: -Random Ports-]
	m_htiRandomPortsResetTime = NULL;
	m_iRandomPortsResetTime = 0;
	// [MoNKi: -Random Ports-]

	//<<< [ionix] SLUGFILLER: lowIdRetry
	m_htiReconnectOnLowID = NULL;
	m_iReconnectOnLowID = 0;
	//>>> [ionix] SLUGFILLER: lowIdRetry
	//<<< [Maella/sivka: -ReAsk SRCs after IP Change-]
	m_htiReaskSrcAfterIpChange = NULL;
	m_bReaskSrcAfterIpChange = false;
	//>>> [Maella/sivka: -ReAsk SRCs after IP Change-]
}

void CPPgIonixConnect::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_EXT_OPTS, m_ctrlTreeOptions);
	if ( !m_bInitializedTreeOpts )
	{
		//>>> [ionix] - Pawcio: BC
		int iImgSlots = 8;
		int iImgPawcioAdv = 8;
		//<<< [ionix] - Pawcio: BC
		int iImgICF = 8; // default icon
		int iImgUPnP = 8; // default icon
		CImageList* piml = m_ctrlTreeOptions.GetImageList(TVSIL_NORMAL);
		if (piml){
			//>>> [ionix] - Pawcio: BC
			iImgSlots		=	piml->Add(CTempIconLoader(_T("ICO_DYNAMIC")));
			iImgPawcioAdv	=	piml->Add(CTempIconLoader(_T("ICO_DYNAMIC_ADV")));
			//<<< [ionix] - Pawcio: BC
			iImgICF			=	piml->Add(CTempIconLoader(_T("PREF_PROXY")));
			iImgUPnP		=	piml->Add(CTempIconLoader(_T("UPNP")));
		}

		//<<< [ionix] SLUGFILLER: lowIdRetry
		m_htiReconnectOnLowID = m_ctrlTreeOptions.InsertItem(_T("Reconnect on LowID"), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, TVI_ROOT);
		m_ctrlTreeOptions.AddEditBox(m_htiReconnectOnLowID, RUNTIME_CLASS(CNumTreeOptionsEdit));
		//>>> [ionix] SLUGFILLER: lowIdRetry

//>>> [ionix] - Deadlist optional
		m_htiIsUseDeadlist = m_ctrlTreeOptions.InsertCheckBox(_T("Use global Deadlist"), TVI_ROOT, m_bIsUseDeadlist);
//<<< [ionix] - Deadlist optional

		//<<< [Maella/sivka: -ReAsk SRCs after IP Change-]
		m_htiReaskSrcAfterIpChange = m_ctrlTreeOptions.InsertCheckBox(_T("Reask Sources after IP Change"), TVI_ROOT, m_bReaskSrcAfterIpChange);
		//>>> [Maella/sivka: -ReAsk SRCs after IP Change-]

//>>> [ionix] - Pawcio: BC
		m_htiSlotGroup = m_ctrlTreeOptions.InsertGroup(_T("Uploadslot settings"), iImgSlots, TVI_ROOT);
		//>>> [ionix] - Max ClientUploadrate
		m_htiMaxClientDatarate = m_ctrlTreeOptions.InsertItem(GetResString(IDS_CLIENT_UPRATE), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiSlotGroup);
		m_ctrlTreeOptions.AddEditBox(m_htiMaxClientDatarate, RUNTIME_CLASS(CNumTreeOptionsEdit));
		//<<< [ionix] - Max ClientUploadrate

		m_htiMinimizeOpenedSlots = m_ctrlTreeOptions.InsertCheckBox( GetResString(IDS_UP_MINIMIZE), m_htiSlotGroup, m_bMinimizeOpenedSlots);
		m_htiCumulateBandwidth = m_ctrlTreeOptions.InsertCheckBox( GetResString(IDS_UP_CUMULATE), m_htiSlotGroup, m_bCumulateBandwidth);
		m_htiBadwulfsUpload = m_ctrlTreeOptions.InsertCheckBox( GetResString(IDS_BADWOLFSUPLOAD), m_htiSlotGroup, m_bBadwulfsUpload);
		m_ctrlTreeOptions.Expand(m_htiSlotGroup, TVE_EXPAND);

		m_htiPawcioAdvGroup = m_ctrlTreeOptions.InsertGroup( _T("Advanced Dynamic Bandwidth Settings"), iImgPawcioAdv, TVI_ROOT);
		CString buffer;
		buffer.Format(_T("%s (BC)"), GetResString(IDS_MANAGE_CONNECTIONS));
		m_htiManageConn = m_ctrlTreeOptions.InsertCheckBox( buffer, m_htiPawcioAdvGroup, m_bManageConn);
		buffer.Format(_T("%s (BC & NAFC)"), GetResString(IDS_PROTOCOL_OVERHEAD));
		m_htiIncludeOH = m_ctrlTreeOptions.InsertCheckBox( buffer, m_htiPawcioAdvGroup, m_bIncludeOH);
		buffer.Format(_T("%s (BC)"), GetResString(IDS_CONNECTIONS_OVERHEAD));
		m_htiConnOH = m_ctrlTreeOptions.InsertCheckBox( buffer, m_htiPawcioAdvGroup, m_bConnOH);
		buffer.Format(_T("%s (BC)"), GetResString(IDS_TCP_ACK));
		m_htiIncludeTCPAck = m_ctrlTreeOptions.InsertCheckBox( buffer, m_htiPawcioAdvGroup, m_bIncludeTCPAck);

		// Pawcio: BC
		m_htiTimeUp = m_ctrlTreeOptions.InsertItem(GetResString(IDS_TIMEUP), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiPawcioAdvGroup);
		m_ctrlTreeOptions.AddEditBox(m_htiTimeUp, RUNTIME_CLASS(CNumTreeOptionsEdit));
		// <--- Pawcio: BC
		// Pawcio: BC Download
		m_htiTimeDown = m_ctrlTreeOptions.InsertItem(GetResString(IDS_TIMEDOWN), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiPawcioAdvGroup);
		m_ctrlTreeOptions.AddEditBox(m_htiTimeDown, RUNTIME_CLASS(CNumTreeOptionsEdit));
		// <--- Pawcio: BC Download

		m_htiZZRatio = m_ctrlTreeOptions.InsertCheckBox( GetResString(IDS_ZZ_RATIO), TVI_ROOT, m_bZZRatio);
//<<< [ionix] - Pawcio: BC

//>>> WiZaRd::NAFC
		/*
		m_htiNAFCGroup = m_ctrlTreeOptions.InsertGroup(_T("NAFC"), iImgDynyp, TVI_ROOT);
		m_htiUseNAFC = m_ctrlTreeOptions.InsertCheckBox(_T("Use NAFC?"), m_htiNAFCGroup, m_bUseNAFC);
		//m_htiNAFCAutoLimit = m_ctrlTreeOptions.InsertCheckBox(_T("NAFC autolimit?"), m_htiNAFCGroup, m_bNAFCAutoLimit);
		m_htiGiveNAFCFullControl = m_ctrlTreeOptions.InsertCheckBox(_T("Give NAFC full control?"), m_htiNAFCGroup, m_bGiveNAFCFullControl);
		m_htiUseDynamicNAFC = m_ctrlTreeOptions.InsertCheckBox(_T("Use dynamic NAFC?"), m_htiNAFCGroup, m_bUseDynamicNAFC);
		m_htiMinNAFCUpload = m_ctrlTreeOptions.InsertItem(_T("Min Upload (0=disalbed)"), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiNAFCGroup);
		m_ctrlTreeOptions.AddEditBox(m_htiMinNAFCUpload, RUNTIME_CLASS(CNumTreeOptionsEdit));
		m_htiMinNAFCDownload = m_ctrlTreeOptions.InsertItem(_T("Min Download (0=disalbed)"), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiNAFCGroup);
		m_ctrlTreeOptions.AddEditBox(m_htiMinNAFCDownload, RUNTIME_CLASS(CNumTreeOptionsEdit));
		if(m_bUseNAFC)
			m_ctrlTreeOptions.Expand(m_htiNAFCGroup, TVE_EXPAND);
		*/
//<<< WiZaRd::NAFC

		m_htiEnableACC = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_ACTIVECONNCONTROL), TVI_ROOT , m_bEnableACC); //Obelix

		// [MoNKi: -Improved ICS-Firewall support-]
		m_htiICFSupportRoot = m_ctrlTreeOptions.InsertGroup(_T("Internet Connection Firewall (ICF)"), iImgICF, TVI_ROOT);
		m_htiICFSupport = m_ctrlTreeOptions.InsertCheckBox(_T("Enable Windows Internet Connection Firewall (ICF) support"), m_htiICFSupportRoot, m_bICFSupport);
		m_htiICFSupportClearAtEnd = m_ctrlTreeOptions.InsertCheckBox(_T("Clear mappings at end"), m_htiICFSupportRoot, m_bICFSupportClearAtEnd);
		m_htiICFSupportServerUDP = m_ctrlTreeOptions.InsertCheckBox(_T("Add mapping for \"ServerUDP\" port"), m_htiICFSupportRoot, m_bICFSupportServerUDP);
		if(m_bICFSupport)
			m_ctrlTreeOptions.Expand(m_htiICFSupportRoot, TVE_EXPAND);
		// [MoNKi: -Improved ICS-Firewall support-]

		// [MoNKi: -UPnPNAT Support-]
		m_htiUPnPRoot = m_ctrlTreeOptions.InsertGroup(_T("Universal Plug & Play (UPnP)"), iImgUPnP, TVI_ROOT);
		m_htiUPnP  = m_ctrlTreeOptions.InsertCheckBox(_T("Enable UPnP on emule ports"), m_htiUPnPRoot, m_bUPnP);
//new upnp - disabled
		m_htiUPnPTryRandom = m_ctrlTreeOptions.InsertCheckBox(_T("Try with external random ports if are in use"), m_htiUPnPRoot, m_bUPnPTryRandom);
//new upnp - disabled
		m_htiUPnPWeb = m_ctrlTreeOptions.InsertCheckBox(_T("Web Interface"), m_htiUPnPRoot, m_bUPnPWeb);
		if(m_bUPnP)
			m_ctrlTreeOptions.Expand(m_htiUPnPRoot, TVE_EXPAND);
		//m_ctrlTreeOptions.Expand(m_htiUPnP, TVE_EXPAND); // do not activate this when new upnp is disabled!
		// [MoNKi: -UPnPNAT Support-]

		// Added by MoNKi [MoNKi: -Random Ports-]
		m_htiRandomPortsResetTime = m_ctrlTreeOptions.InsertItem(_T("Random ports safe restart time"), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, TVI_ROOT);
		m_ctrlTreeOptions.AddEditBox(m_htiRandomPortsResetTime, RUNTIME_CLASS(CNumTreeOptionsEdit));
		// End MoNKi

		/* [ionix] - moved up
		// Pawcio: BC
		m_htiTimeUp = m_ctrlTreeOptions.InsertItem(GetResString(IDS_TIMEUP), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiTimeUp, TVI_ROOT);
		m_ctrlTreeOptions.AddEditBox(m_htiTimeUp, RUNTIME_CLASS(CNumTreeOptionsEdit));
		// <--- Pawcio: BC
		// Pawcio: BC Download
		m_htiTimeDown = m_ctrlTreeOptions.InsertItem(GetResString(IDS_TIMEDOWN), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiTimeDown, TVI_ROOT);
		m_ctrlTreeOptions.AddEditBox(m_htiTimeDown, RUNTIME_CLASS(CNumTreeOptionsEdit));
		// <--- Pawcio: BC Download
		*/

		m_ctrlTreeOptions.SelectItem(m_ctrlTreeOptions.GetRootItem());
		m_bInitializedTreeOpts = true;
	}

	//<<< [ionix] SLUGFILLER: lowIdRetry
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiReconnectOnLowID, m_iReconnectOnLowID);
	DDV_MinMaxInt(pDX, m_iReconnectOnLowID, 0, 20);
	//>>> [ionix] SLUGFILLER: lowIdRetry

//>>> [ionix] - Deadlist optional
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiIsUseDeadlist, m_bIsUseDeadlist);
//<<< [ionix] - Deadlist optional

	//<<< [Maella/sivka: -ReAsk SRCs after IP Change-]
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiReaskSrcAfterIpChange, m_bReaskSrcAfterIpChange);
	//>>> [Maella/sivka: -ReAsk SRCs after IP Change-]

//>>> [ionix] - Pawcio: BC
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiZZRatio, m_bZZRatio);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiMinimizeOpenedSlots, m_bMinimizeOpenedSlots);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiCumulateBandwidth, m_bCumulateBandwidth);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiBadwulfsUpload, m_bBadwulfsUpload);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiManageConn, m_bManageConn);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiIncludeOH, m_bIncludeOH);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiConnOH, m_bConnOH);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiIncludeTCPAck, m_bIncludeTCPAck);
//<<< [ionix] - Pawcio: BC

//>>> [ionix] - Max ClientUploadrate
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiMaxClientDatarate, (int &)m_uMaxClientDatarate);
	DDV_MinMaxInt(pDX, m_uMaxClientDatarate, UPLOAD_CLIENT_DATARATE>>10, max(3, thePrefs.GetMaxUpload() == UNLIMITED ? (uint32)thePrefs.maxGraphUploadRate/3 : (uint32)thePrefs.GetMaxUpload()/3));
//<<< [ionix] - Max ClientUploadrate

//>>> WiZaRd::NAFC
	/*
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiUseNAFC, m_bUseNAFC);
	//DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiNAFCAutoLimit, m_bNAFCAutoLimit);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiGiveNAFCFullControl, m_bGiveNAFCFullControl);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiUseDynamicNAFC, m_bUseDynamicNAFC);
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiMinNAFCUpload, m_uMinNAFCUpload);
	DDV_MinMaxUInt(pDX, m_uMinNAFCUpload, 0, thePrefs.GetMaxUpload());
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiMinNAFCDownload, m_uMinNAFCDownload);
	DDV_MinMaxUInt(pDX, m_uMinNAFCDownload, 0, thePrefs.GetMaxDownload());
//<<< WiZaRd::NAFC
//>>> [ionix] - NAFC
	//m_ctrlTreeOptions.SetCheckBoxEnable(m_htiNAFCAutoLimit, m_bUseNAFC);
	m_ctrlTreeOptions.SetCheckBoxEnable(m_htiGiveNAFCFullControl, m_bUseNAFC);
	m_ctrlTreeOptions.SetCheckBoxEnable(m_htiUseDynamicNAFC, m_bUseNAFC);
	*/
//<<< [ionix] - NAFC

//>>> [ionix] - Pawcio: BC
	m_ctrlTreeOptions.SetCheckBoxEnable(m_htiCumulateBandwidth, !m_bBadwulfsUpload);
	m_ctrlTreeOptions.SetCheckBoxEnable(m_htiMinimizeOpenedSlots, !m_bBadwulfsUpload);
	m_ctrlTreeOptions.SetCheckBoxEnable(m_htiManageConn, !m_bBadwulfsUpload);
	m_ctrlTreeOptions.SetCheckBoxEnable(m_htiZZRatio, (!m_bIncludeTCPAck && !m_bConnOH && !m_bManageConn));
	m_ctrlTreeOptions.SetGroupEnable(m_htiPawcioAdvGroup, thePrefs.advancedBC);
//<<< [ionix] - Pawcio: BC

	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiEnableACC, m_bEnableACC); //Obelix

	// [MoNKi: -UPnPNAT Support-]
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiUPnP, m_bUPnP);
//new upnp - disabled start
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiUPnPTryRandom, m_bUPnPTryRandom);
//new upnp - disabled end
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiUPnPWeb, m_bUPnPWeb);
//new upnp - disabled start
	m_ctrlTreeOptions.SetCheckBoxEnable(m_htiUPnPTryRandom, m_bUPnP);
//new upnp - disabled end
	// [MoNKi: -UPnPNAT Support-]

	// [MoNKi: -Random Ports-]
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiRandomPortsResetTime, m_iRandomPortsResetTime);
	DDV_MinMaxInt(pDX, m_iRandomPortsResetTime, 0, 900);
	// [MoNKi: -Random Ports-]

	// [MoNKi: -Improved ICS-Firewall support-]
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiICFSupport, m_bICFSupport);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiICFSupportClearAtEnd, m_bICFSupportClearAtEnd);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiICFSupportServerUDP, m_bICFSupportServerUDP);
	// [MoNKi: -Improved ICS-Firewall support-]

	// Pawcio: BC
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiTimeUp, m_iTimeUp);
	DDV_MinMaxInt(pDX, m_iTimeUp, 1, 250);
	// <--- Pawcio: BC
	// Pawcio: BC Download
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiTimeDown, m_iTimeDown);
	DDV_MinMaxInt(pDX, m_iTimeDown, 1, 250);
	// <--- Pawcio: BC Download
}

BEGIN_MESSAGE_MAP(CPPgIonixConnect, CPropertyPage)
	//>>> [ionix] Fenderman - Spooky Mode [eWombat]	
	ON_BN_CLICKED(IDC_EnableSpookyMode, OnSettingsChange) 	
	ON_BN_CLICKED(IDC_ReconSpooky, OnSettingsChange) 						
	ON_BN_CLICKED(IDC_SpookyFailed, OnSpookyFailedChange)					
	ON_EN_CHANGE(IDC_SpookyFailedCount, OnSettingsChange)				
	//<<< [ionix] Fenderman - Spooky Mode [eWombat]
	//>>> WiZaRd: Spooky Mode ConChecker Addon
	ON_BN_CLICKED(IDC_GetCheckCon, OnConCheckerChange)
	ON_BN_CLICKED(IDC_GetICMP, OnSettingsChange)
	ON_EN_CHANGE(IDC_GetPingTimeout, OnSettingsChange)
	ON_EN_CHANGE(IDC_GetPingTTL, OnSettingsChange)
	//<<< WiZaRd: Spooky Mode ConChecker Addon
	//>>> [ionix]: quick start [TPT]
	ON_BN_CLICKED(IDC_PPG_PHOENIX_QUICKSTART, OnBnClickedQuickStart)	
	ON_EN_CHANGE(IDS_QUICK_START_MAX_CONN, OnSettingsChange)
	ON_EN_CHANGE(IDS_QUICK_START_MAX_CONN_PER_FIVE, OnSettingsChange)
	ON_EN_CHANGE(IDS_QUICK_START_MINUTES, OnSettingsChange)
	ON_BN_CLICKED(IDC_QUICKSTARTAFTERIPCHANGE, OnSettingsChange) // [ionix] quickstart after ip change
	//<<< [ionix]: quick start [TPT]
	//ON_BN_CLICKED(IDC_SELECTNAFC, SelectNAFC) //>>> WiZaRd::NAFC
	ON_MESSAGE(UM_TREEOPTSCTRL_NOTIFY, OnTreeOptsCtrlNotify)
	ON_WM_DESTROY()
	ON_WM_HELPINFO() //<<< [ionix] - ionixguide
END_MESSAGE_MAP()

BOOL CPPgIonixConnect::OnInitDialog()
{
	((CEdit*)GetDlgItem(IDC_SpookyFailedCount))->SetLimitText(2); // [ionix] Fenderman - Spooky Mode [eWombat]

	((CEdit*)GetDlgItem(IDS_QUICK_START_MAX_CONN))->SetLimitText(4); // [TPT] - quick start
	((CEdit*)GetDlgItem(IDS_QUICK_START_MAX_CONN_PER_FIVE))->SetLimitText(3); // [TPT] - quick start
	((CEdit*)GetDlgItem(IDS_QUICK_START_MINUTES))->SetLimitText(2); // [TPT] - quick start

	// Added by MoNKi [MoNKi: -Random Ports-]
	m_iRandomPortsResetTime = thePrefs.GetRandomPortsSafeResetOnRestartTime();
	// End MoNKi

	// [MoNKi: -UPnPNAT Support-]
	m_bUPnP = thePrefs.GetUPnPNat();
//new upnp - disabled
	m_bUPnPTryRandom = thePrefs.GetUPnPNatTryRandom();
//new upnp - disabled
	m_bUPnPWeb = thePrefs.GetUPnPNatWeb();
	// [MoNKi: -UPnPNAT Support-]

	// [MoNKi: -Improved ICS-Firewall support-]
	m_bICFSupport = thePrefs.GetICFSupport();
	m_bICFSupportClearAtEnd = thePrefs.IsOpenPortsOnStartupEnabled();
	m_bICFSupportServerUDP = thePrefs.GetICFSupportServerUDP();
	// [MoNKi: -Improved ICS-Firewall support-]

	//<<< [ionix] SLUGFILLER: lowIdRetry
	m_iReconnectOnLowID = thePrefs.GetLowIdRetries();
	//>>> [ionix] SLUGFILLER: lowIdRetry

//>>> [ionix] - Deadlist optional
	m_bIsUseDeadlist = thePrefs.IsUseDeadlist();
//<<< [ionix] - Deadlist optional

	//<<< [Maella/sivka: -ReAsk SRCs after IP Change-]
	m_bReaskSrcAfterIpChange = thePrefs.bReAskSRCAfterIPChange;
	//>>> [Maella/sivka: -ReAsk SRCs after IP Change-]

	m_iTimeUp = thePrefs.BCTimeUp; // Pawcio: BC
	m_iTimeDown = thePrefs.BCTimeDown; // Pawcio: BC Download

	m_bEnableACC = thePrefs.m_activeConnectionControl; //Obelix

//>>> [ionix] - Pawcio: BC
	m_bZZRatio = thePrefs.ZZRatio;
	m_bMinimizeOpenedSlots = thePrefs.minimizeOpenedSlots;
	m_bCumulateBandwidth = thePrefs.cumulateBandwidth;
	m_bBadwulfsUpload = thePrefs.BadwolfsUpload;
	m_bManageConn = thePrefs.manageConnections;
	m_bIncludeOH = thePrefs.includeOverhead;
	m_bConnOH = thePrefs.connectionsOverhead;
	m_bIncludeTCPAck = thePrefs.includeTCPAck;
//<<< [ionix] - Pawcio: BC

	//>>> [ionix] - Max ClientUploadrate
	m_uMaxClientDatarate = thePrefs.GetMaxClientDatarate()>>10;
	//<<< [ionix] - Max ClientUploadrate

	// [ionix] - NAFC
	/*
	if(m_bUseNAFC && !thePrefs.GetNAFCEnable()) // send an info message
		AddModLogLine(LOG_WARNING, GetResString(IDS_NAFC_INFO));
//>>> WiZaRd::NAFC
	m_bUseNAFC = thePrefs.GetNAFCEnable();
	//m_bNAFCAutoLimit = thePrefs.GetNAFCAutoLimit();
	m_bGiveNAFCFullControl = thePrefs.GetNAFCFullControl();
	m_bUseDynamicNAFC = thePrefs.GetDynamicNAFC();
	m_uMinNAFCUpload = thePrefs.GetMinNAFCUpload();
	m_uMinNAFCDownload = thePrefs.GetMinNAFCDownload();
	*/
//<<< WiZaRd::NAFC

	CPropertyPage::OnInitDialog();
	InitWindowStyles(this);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgIonixConnect::LoadSettings(void){

	if(m_hWnd)
	{
		CString strBuffer;

		//>>> [ionix] Fenderman - Spooky Mode [eWombat]
		CheckDlgButton(IDC_EnableSpookyMode, thePrefs.EnableSpookyMode());
		CheckDlgButton(IDC_ReconSpooky, thePrefs.GetReconSpooky());
		CheckDlgButton(IDC_SpookyFailed, thePrefs.GetSpookyFailed());
		GetDlgItem(IDC_SpookyFailedCount)->EnableWindow(thePrefs.GetSpookyFailed()); 
		strBuffer.Format(_T("%u"), thePrefs.m_iSpookyFailedCount);
		GetDlgItem(IDC_SpookyFailedCount)->SetWindowText(strBuffer);		
		//<<< [ionix] Fenderman - Spooky Mode [eWombat]

		//>>> WiZaRd: Spooky Mode ConChecker Addon 
		CheckDlgButton(IDC_GetCheckCon, thePrefs.GetCheckCon());
		CheckDlgButton(IDC_GetICMP, thePrefs.GetICMP());

		strBuffer.Format(_T("%u"), thePrefs.GetPingTimeout());
		GetDlgItem(IDC_GetPingTimeout)->SetWindowText(strBuffer);

		strBuffer.Format(_T("%u"), thePrefs.GetPingTTL());
		GetDlgItem(IDC_GetPingTTL)->SetWindowText(strBuffer);
		OnConCheckerChange(); // [ionix]: added
		//<<< WiZaRd: Spooky Mode ConChecker Addon 

		//>>> [ionix]: quick start [TPT]
		GetDlgItem(IDS_QUICK_START_MAX_CONN)->EnableWindow(thePrefs.GetQuickStart()); 
		GetDlgItem(IDS_QUICK_START_MAX_CONN_PER_FIVE)->EnableWindow(thePrefs.GetQuickStart()); 
		GetDlgItem(IDS_QUICK_START_MINUTES)->EnableWindow(thePrefs.GetQuickStart()); 

		strBuffer.Format(_T("%d"), thePrefs.GetQuickStartMaxCon()); 
		GetDlgItem(IDS_QUICK_START_MAX_CONN)->SetWindowText(strBuffer); 
		strBuffer.Format(_T("%d"), thePrefs.GetQuickStartMaxConPerFive());
		GetDlgItem(IDS_QUICK_START_MAX_CONN_PER_FIVE)->SetWindowText(strBuffer);
		strBuffer.Format(_T("%d"), thePrefs.GetQuickStartMinutes());
		GetDlgItem(IDS_QUICK_START_MINUTES)->SetWindowText(strBuffer);
		CheckDlgButton(IDC_PPG_PHOENIX_QUICKSTART, thePrefs.GetQuickStart()); 
		//<<< [ionix]: quick start [TPT]
		//>>> [ionix] quickstart after ip change
		CheckDlgButton(IDC_QUICKSTARTAFTERIPCHANGE, thePrefs.GetQuickStartAfterIPChange());
		//<<< [ionix] quickstart after ip change
	}
}

BOOL CPPgIonixConnect::OnApply()
{
	CString sBuffer;

	//>>> [ionix] Fenderman - Spooky Mode [eWombat]
	thePrefs.m_bEnableSpookyMode = IsDlgButtonChecked(IDC_EnableSpookyMode)!=0;
	thePrefs.m_bReconSpooky = IsDlgButtonChecked(IDC_ReconSpooky)!=0;
	thePrefs.m_bSpookyFailed = IsDlgButtonChecked(IDC_ReconSpooky)!=0;

	if(GetDlgItem(IDC_SpookyFailedCount)->GetWindowTextLength())
	{
		GetDlgItem(IDC_SpookyFailedCount)->GetWindowText(sBuffer);
		thePrefs.m_iSpookyFailedCount = (_tstoi(sBuffer)) ? _tstoi(sBuffer) : 5;
	}
	//<<< [ionix] Fenderman - Spooky Mode [eWombat]

	//>>> WiZaRd: Spooky Mode ConChecker Addon 
	bool m_bTest = thePrefs.m_bCheckCon;
	thePrefs.m_bCheckCon = IsDlgButtonChecked(IDC_GetCheckCon)!=0;
	if(m_bTest != thePrefs.m_bCheckCon)
	{
		//wasn't activated? start now...
		if (!m_bTest) 
			theApp.conchecker.Process((DWORD)0);
		//was running? shut down...
		else
		{
			theApp.conchecker.SetForceMode(CONFORCE_NULL);
			if (theApp.serverconnect->IsSpooky())
				theApp.serverconnect->DisconnectSpooky();
			if (theApp.GetConnectionState()==CONSTATE_OFFLINE)
				theApp.SetConnectionState(CONSTATE_ONLINE);
		}
	}

	thePrefs.m_bICMP = IsDlgButtonChecked(IDC_GetICMP)!=0;

	if(GetDlgItem(IDC_GetPingTimeout)->GetWindowTextLength())
	{
		GetDlgItem(IDC_GetPingTimeout)->GetWindowText(sBuffer);
		thePrefs.m_uiPingTimeOut = (_tstoi(sBuffer)) ? _tstoi(sBuffer) : 5;
	}

	if(GetDlgItem(IDC_GetPingTTL)->GetWindowTextLength())
	{
		GetDlgItem(IDC_GetPingTTL)->GetWindowText(sBuffer);
		thePrefs.m_uiPingTTL = (_tstoi(sBuffer)) ? _tstoi(sBuffer) : 5;
	}
	//<<< WiZaRd: Spooky Mode ConChecker Addon 

	//>>> [ionix]: quick start [TPT]
	GetDlgItem(IDS_QUICK_START_MAX_CONN)->GetWindowText(sBuffer); 
	thePrefs.SetQuickStartMaxCon(_tstoi(sBuffer));
	if(thePrefs.GetQuickStartMaxCon() < 100) //kleiner 100 geht nicht 
	{ 
		thePrefs.SetQuickStartMaxCon(1201); // Startwert = 1201
		sBuffer.Format(_T("%d"),thePrefs.GetQuickStartMaxCon()); 
		GetDlgItem(IDS_QUICK_START_MAX_CONN)->SetWindowText(sBuffer); 
	} 
	else if(thePrefs.GetQuickStartMaxCon() >2000) //grsser 2000  wollen wir nicht.... 
	{ 
		thePrefs.SetQuickStartMaxCon(2000); 
		sBuffer.Format(_T("%d"),thePrefs.GetQuickStartMaxCon()); 
		GetDlgItem(IDS_QUICK_START_MAX_CONN)->SetWindowText(sBuffer); 
	} 
	GetDlgItem(IDS_QUICK_START_MAX_CONN_PER_FIVE)->GetWindowText(sBuffer); 
	thePrefs.SetQuickStartMaxConPerFive(_tstoi(sBuffer));
	if(thePrefs.GetQuickStartMaxConPerFive() < 50) //kleiner 50 geht nicht 
	{ 
		thePrefs.SetQuickStartMaxConPerFive(151); // Startwert = 151
		sBuffer.Format(_T("%d"),thePrefs.GetQuickStartMaxConPerFive()); 
		GetDlgItem(IDS_QUICK_START_MAX_CONN_PER_FIVE)->SetWindowText(sBuffer); 
	} 
	else if(thePrefs.GetQuickStartMaxConPerFive() >200) //grsser 200  wollen wir nicht.... 
	{ 
		thePrefs.SetQuickStartMaxConPerFive(200); 
		sBuffer.Format(_T("%d"),thePrefs.GetQuickStartMaxConPerFive()); 
		GetDlgItem(IDS_QUICK_START_MAX_CONN_PER_FIVE)->SetWindowText(sBuffer); 
	}
	GetDlgItem(IDS_QUICK_START_MINUTES)->GetWindowText(sBuffer); 
	thePrefs.SetQuickStartMinutes(_tstoi(sBuffer));
	if(thePrefs.GetQuickStartMinutes() < 5) //kleiner 5 geht nicht 
	{ 
		thePrefs.SetQuickStartMinutes(10); // Startwert = 151
		sBuffer.Format(_T("%d"),thePrefs.GetQuickStartMinutes()); 
		GetDlgItem(IDS_QUICK_START_MINUTES)->SetWindowText(sBuffer); 
	} 
	else if(thePrefs.GetQuickStartMinutes() >30) //grsser 30  wollen wir nicht.... 
	{ 
		thePrefs.SetQuickStartMinutes(10); 
		sBuffer.Format(_T("%d"),thePrefs.GetQuickStartMinutes()); 
		GetDlgItem(IDS_QUICK_START_MINUTES)->SetWindowText(sBuffer); 
	}
	thePrefs.m_QuickStart = IsDlgButtonChecked(IDC_PPG_PHOENIX_QUICKSTART)!=0; 
	//<<< [ionix]: quick start [TPT]

	//>>> [ionix] quickstart after ip change
	thePrefs.m_bQuickStartAfterIPChange = IsDlgButtonChecked(IDC_QUICKSTARTAFTERIPCHANGE)!=0; 
	//<<< [ionix] quickstart after ip change

	bool bRestartApp = false;

	//<<< [ionix] SLUGFILLER: lowIdRetry
	thePrefs.LowIdRetries = m_iReconnectOnLowID;
	//>>> [ionix] SLUGFILLER: lowIdRetry

//>>> [ionix] - Deadlist optional
	thePrefs.SetUseDeadlist(m_bIsUseDeadlist);
//<<< [ionix] - Deadlist optional

	//<<< [Maella/sivka: -ReAsk SRCs after IP Change-]
	thePrefs.bReAskSRCAfterIPChange = m_bReaskSrcAfterIpChange!=0;
	//>>> [Maella/sivka: -ReAsk SRCs after IP Change-]

		// [MoNKi: -UPnPNAT Support-]
	if((BOOL)thePrefs.GetUPnPNat() != m_bUPnP ||
		(BOOL)thePrefs.GetUPnPNatTryRandom() != m_bUPnPTryRandom || //new upnp - disabled
		(BOOL)thePrefs.GetUPnPNatWeb() != m_bUPnPWeb)
	{
		bRestartApp = true;
	}
	thePrefs.SetUPnPNat(m_bUPnP!=0);
	thePrefs.SetUPnPNatTryRandom(m_bUPnPTryRandom!=0); //new upnp - disabled
	thePrefs.SetUPnPNatWeb(m_bUPnPWeb!=0);
	// [MoNKi: -UPnPNAT Support-]

	// [MoNKi: -Improved ICS-Firewall support-]
	if(thePrefs.m_bICFSupportStatusChanged){
		m_ctrlTreeOptions.SetCheckBox(m_htiICFSupport,thePrefs.GetICFSupport());
		m_bICFSupport = thePrefs.GetICFSupport();
		thePrefs.m_bICFSupportStatusChanged = false;
	}

	if((BOOL)thePrefs.GetICFSupport() != m_bICFSupport
		|| (BOOL)thePrefs.IsOpenPortsOnStartupEnabled() != m_bICFSupportClearAtEnd
		|| (BOOL)thePrefs.GetICFSupportServerUDP() != m_bICFSupportServerUDP)
	{
		bRestartApp = true;
	}
	thePrefs.SetICFSupport(m_bICFSupport!=0);
	thePrefs.SetOpenPortsOnStartup(m_bICFSupportClearAtEnd!=0);
	thePrefs.SetICFSupportServerUDP(m_bICFSupportServerUDP!=0);
	// [MoNKi: -Improved ICS-Firewall support-]

//>>> [ionix] - Pawcio: BC
	thePrefs.ZZRatio = m_bZZRatio;
	if (thePrefs.minimizeOpenedSlots != m_bMinimizeOpenedSlots ||
		thePrefs.cumulateBandwidth != m_bCumulateBandwidth)
		theApp.uploadBandwidthThrottler->ResetBC();
	thePrefs.minimizeOpenedSlots = m_bMinimizeOpenedSlots;
	thePrefs.cumulateBandwidth = m_bCumulateBandwidth;
	thePrefs.BadwolfsUpload = m_bBadwulfsUpload!=0;
	thePrefs.manageConnections = m_bManageConn!=0;
	thePrefs.includeOverhead = m_bIncludeOH;
	thePrefs.connectionsOverhead = m_bConnOH!=0;
	thePrefs.includeTCPAck = m_bIncludeTCPAck!=0;
//<<< [ionix] - Pawcio: BC

	//>>> [ionix] - Max ClientUploadrate
	thePrefs.m_uMaxClientDatarate = m_uMaxClientDatarate<<10;
	//<<< [ionix] - Max ClientUploadrate

//>>> WiZaRd::NAFC
	/*
	//thePrefs.SetNAFCAutoLimit(m_bNAFCAutoLimit);
	thePrefs.SetNAFCEnable(m_bUseNAFC!=0);
	thePrefs.SetNAFCFullControl(m_bGiveNAFCFullControl);
	thePrefs.SetDynamicNAFC(m_bUseDynamicNAFC);
	thePrefs.SetMinNAFCUpload(m_uMinNAFCUpload);
	thePrefs.SetMinNAFCDownload(m_uMinNAFCDownload);
	*/
//<<< WiZaRd::NAFC

	thePrefs.m_activeConnectionControl = m_bEnableACC; //Obelix

	// Pawcio: BC
	thePrefs.BCTimeUp = m_iTimeUp;
	theApp.uploadBandwidthThrottler->SetTimeUp(m_iTimeUp);
	// <--- Pawcio: BC
	// Pawcio: BC Download
	thePrefs.BCTimeDown = m_iTimeDown; // Pawcio: BC Download
	theApp.downloadBandwidthThrottler->SetTimeDown(m_iTimeDown);
	// <--- Pawcio: BC Download

	if (bRestartApp)
		AfxMessageBox(GetResString(IDS_SETTINGCHANGED_RESTART));

	SetModified(FALSE);

	LoadSettings();
	return CPropertyPage::OnApply();
}

void CPPgIonixConnect::Localize(void)
{
	if(m_hWnd)
	{	
		//>>> [ionix] Fenderman - Spooky Mode [eWombat]
		GetDlgItem(IDC_SpookyModeStatic)->SetWindowText(GetResString(IDS_SpookyModeStatic));
		GetDlgItem(IDC_EnableSpookyMode)->SetWindowText(GetResString(IDS_EnableSpookyMode));
		GetDlgItem(IDC_ReconSpooky)->SetWindowText(GetResString(IDS_ReconSpooky));
		GetDlgItem(IDC_SpookyFailed)->SetWindowText(GetResString(IDS_SpookyFailed));
		GetDlgItem(IDC_SpookyFailedCountStatic)->SetWindowText(GetResString(IDS_SpookyFailedCountStatic));
		//<<< [ionix] Fenderman - Spooky Mode [eWombat]

		//>>> WiZaRd: Spooky Mode ConChecker Addon 
		GetDlgItem(IDC_ConCheckerStatic)->SetWindowText(GetResString(IDS_ConCheckerStatic));
		GetDlgItem(IDC_GetCheckCon)->SetWindowText(GetResString(IDS_GetCheckCon));
		GetDlgItem(IDC_GetICMP)->SetWindowText(GetResString(IDS_GetICMP));
		GetDlgItem(IDC_GetPingTimeoutStatic)->SetWindowText(GetResString(IDS_GetPingTimeoutStatic));
		GetDlgItem(IDC_GetPingTTLStatic)->SetWindowText(GetResString(IDS_GetPingTTLStatic));
		//<<< WiZaRd: Spooky Mode ConChecker Addon 

		//>>> [ionix]: quick start [TPT]
		GetDlgItem(IDC_QUICKSTART_BOX)->SetWindowText(GetResString(IDS_QUICKSTART));
		GetDlgItem(IDC_PPG_PHOENIX_QUICKSTART)->SetWindowText(GetResString(IDS_PPG_PHOENIX_QUICKSTART));
		GetDlgItem(IDC_PPG_PHOENIX_QUICKSTART_CONN_STATIC)->SetWindowText(GetResString(IDS_PPG_PHOENIX_QUICKSTART_CONN_STATIC));
		GetDlgItem(IDC_PPG_PHOENIX_QUICKSTART_CONN_PER_FIVE_STATIC)->SetWindowText(GetResString(IDS_PPG_PHOENIX_QUICKSTART_CONN_PER_FIVE_STATIC));
		//>>> [ionix] quickstart after ip change
		GetDlgItem(IDC_QUICKSTARTAFTERIPCHANGE)->SetWindowText(GetResString(IDS_QUICKSTARTAFTERIPCHANGE));
		//<<< [ionix] quickstart after ip change
		GetDlgItem(IDC_QUICK_START_MINUTES_STATIC)->SetWindowText(GetResString(IDS_QUICK_START_MINUTES_STATIC));
		//<<< [ionix]: quick start [TPT]

		//<<< [ionix] SLUGFILLER: lowIdRetry
		if(m_htiReconnectOnLowID) m_ctrlTreeOptions.SetEditLabel(m_htiReconnectOnLowID, GetResString(IDS_RECONNECTONLOWID));
		//>>> [ionix] SLUGFILLER: lowIdRetry

//>>> [ionix] - Deadlist optional
		if(m_htiIsUseDeadlist) m_ctrlTreeOptions.SetItemText(m_htiIsUseDeadlist, GetResString(IDS_USE_DEADLIST));
//<<< [ionix] - Deadlist optional

		// >>> [Maella/sivka: -ReAsk SRCs after IP Change-]
		if(m_htiReaskSrcAfterIpChange) m_ctrlTreeOptions.SetItemText(m_htiReaskSrcAfterIpChange, GetResString(IDS_REASKSRCAFTERIPCHANGE));
		// <<< [Maella/sivka: -ReAsk SRCs after IP Change-]

		// [MoNKi: -Improved ICS-Firewall support-]
		if (m_htiICFSupport){
			m_ctrlTreeOptions.SetItemText(m_htiICFSupportRoot, GetResString(IDS_ICF));
			m_ctrlTreeOptions.SetItemText(m_htiICFSupport, GetResString(IDS_ICFSUPPORT));
			m_ctrlTreeOptions.SetItemText(m_htiICFSupportClearAtEnd, GetResString(IDS_FO_PREF_STARTUP));
			m_ctrlTreeOptions.SetItemText(m_htiICFSupportServerUDP, GetResString(IDS_ICF_SERVERUDP));
		}
		// [MoNKi: -Improved ICS-Firewall support-]

		// [MoNKi: -UPnPNAT Support-]
		if(m_htiUPnPWeb)
		{
			CString tmpString, tmpString2;
			tmpString.Format(GetResString(IDS_UPNPNAT), GetResString(IDS_UPNPNATEMULE));
			m_ctrlTreeOptions.SetItemText(m_htiUPnP, tmpString);
			tmpString.Format(GetResString(IDS_UPNPNAT), GetResString(IDS_PW_WS));
			m_ctrlTreeOptions.SetItemText(m_htiUPnPWeb, tmpString);
		}
//new upnp - disabled
		if(m_htiUPnPTryRandom) m_ctrlTreeOptions.SetItemText(m_htiUPnPTryRandom, GetResString(IDS_UPNPNATTRYRANDOM));		
//new upnp - disabled
		// [MoNKi: -UPnPNAT Support-]

		// Added by MoNKi [MoNKi: -Random Ports-]
		if(m_htiRandomPortsResetTime)
			m_ctrlTreeOptions.SetEditLabel(m_htiRandomPortsResetTime, GetResString(IDS_RANDOMPORTSRESETTIME));
		// End MoNKi
		
//>>> [ionix] - Pawcio: BC
		if (m_htiSlotGroup) m_ctrlTreeOptions.SetItemText(m_htiSlotGroup, GetResString(IDS_PAWCIOCONTROL));
		if (m_htiZZRatio) m_ctrlTreeOptions.SetItemText(m_htiZZRatio, GetResString(IDS_ZZ_RATIO));
		if (m_htiMinimizeOpenedSlots) m_ctrlTreeOptions.SetItemText(m_htiMinimizeOpenedSlots, GetResString(IDS_UP_MINIMIZE));
		if (m_htiCumulateBandwidth) m_ctrlTreeOptions.SetItemText(m_htiCumulateBandwidth, GetResString(IDS_UP_CUMULATE));
		if (m_htiBadwulfsUpload) m_ctrlTreeOptions.SetItemText(m_htiBadwulfsUpload, GetResString(IDS_BADWOLFSUPLOAD));
		if (m_htiPawcioAdvGroup) m_ctrlTreeOptions.SetItemText(m_htiPawcioAdvGroup, GetResString(IDS_ADVANCED));
		CString buffer;
		buffer.Format(_T("%s (BC)"), GetResString(IDS_MANAGE_CONNECTIONS));
		if (m_htiManageConn) m_ctrlTreeOptions.SetItemText(m_htiManageConn, buffer);
		buffer.Format(_T("%s (BC & NAFC)"), GetResString(IDS_PROTOCOL_OVERHEAD));
		if (m_htiIncludeOH) m_ctrlTreeOptions.SetItemText(m_htiIncludeOH, buffer);
		buffer.Format(_T("%s (BC)"), GetResString(IDS_CONNECTIONS_OVERHEAD));
		if (m_htiConnOH) m_ctrlTreeOptions.SetItemText(m_htiConnOH, buffer);
		buffer.Format(_T("%s (BC)"), GetResString(IDS_TCP_ACK));
		if (m_htiIncludeTCPAck) m_ctrlTreeOptions.SetItemText(m_htiIncludeTCPAck, buffer);
//<<< [ionix] - Pawcio: BC

//>>> [ionix] - Max ClientUploadrate
		if (m_htiMaxClientDatarate) m_ctrlTreeOptions.SetEditLabel(m_htiMaxClientDatarate, GetResString(IDS_CLIENT_UPRATE));
//<<< [ionix] - Max ClientUploadrate

		//>>> [ionix] - NAFC
		/*
		if (m_htiUseNAFC) m_ctrlTreeOptions.SetItemText(m_htiUseNAFC, GetResString(IDS_NAFC_USE));
		if (m_htiGiveNAFCFullControl) m_ctrlTreeOptions.SetItemText(m_htiGiveNAFCFullControl, GetResString(IDS_NAFC_FULLCONTROL));
		if (m_htiUseDynamicNAFC) m_ctrlTreeOptions.SetItemText(m_htiUseDynamicNAFC, GetResString(IDS_NAFC_DYNAMIC));
		if (m_htiMinNAFCUpload) m_ctrlTreeOptions.SetItemText(m_htiMinNAFCUpload, GetResString(IDS_NAFC_MINUPLOAD));
		if (m_htiMinNAFCDownload) m_ctrlTreeOptions.SetItemText(m_htiMinNAFCDownload, GetResString(IDS_NAFC_MAXUPLOAD));
		*/
		//<<<< [ionix] - NAFC

		if (m_htiEnableACC) m_ctrlTreeOptions.SetItemText(m_htiEnableACC, GetResString(IDS_ACTIVECONNCONTROL)); //Obelix
		if (m_htiTimeUp) m_ctrlTreeOptions.SetEditLabel(m_htiTimeUp, GetResString(IDS_TIMEUP)); // Pawcio: BC
		if (m_htiTimeDown) m_ctrlTreeOptions.SetEditLabel(m_htiTimeDown, GetResString(IDS_TIMEDOWN)); // Pawcio: BC Download

	}
}

CPPgIonixConnect::~CPPgIonixConnect(void)
{
}


LRESULT CPPgIonixConnect::OnTreeOptsCtrlNotify(WPARAM wParam, LPARAM lParam)
{
	if (wParam == IDC_EXT_OPTS)
	{
		TREEOPTSCTRLNOTIFY* pton = (TREEOPTSCTRLNOTIFY*)lParam;
//new upnp - disabled
		// [MoNKi: -UPnPNAT Support-]
		if (pton->hItem == m_htiUPnP){
			if(m_ctrlTreeOptions.GetCheckBox(m_htiUPnP, m_bUPnP)){
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiUPnPTryRandom, m_bUPnP);
			}
		}
		// [MoNKi: -UPnPNAT Support-]
//new upnp - disabled
//>>> [ionix] - Pawcio: BC
		else if(pton->hItem == m_htiBadwulfsUpload)
		{
			if(m_ctrlTreeOptions.GetCheckBox(m_htiBadwulfsUpload, m_bBadwulfsUpload))
			{
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiCumulateBandwidth, !m_bBadwulfsUpload);
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiMinimizeOpenedSlots, !m_bBadwulfsUpload);
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiManageConn, !m_bBadwulfsUpload);
			}
		}
		else if(pton->hItem == m_htiIncludeTCPAck)
		{
			if(m_ctrlTreeOptions.GetCheckBox(m_htiIncludeTCPAck, m_bIncludeTCPAck))
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiZZRatio, (!m_bIncludeTCPAck && !m_bConnOH && !m_bManageConn));
		}
		else if(pton->hItem == m_htiConnOH)
		{
			if(m_ctrlTreeOptions.GetCheckBox(m_htiConnOH, m_bConnOH))
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiZZRatio, (!m_bIncludeTCPAck && !m_bConnOH && !m_bManageConn));
		}
		else if(pton->hItem == m_htiManageConn)
		{
			if(m_ctrlTreeOptions.GetCheckBox(m_htiManageConn, m_bManageConn))
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiZZRatio, (!m_bIncludeTCPAck && !m_bConnOH && !m_bManageConn));
		}
//<<< [ionix] - Pawcio: BC

//>>> [ionix] - NAFC
		/*
		else if (pton->hItem == m_htiUseNAFC){
			if(m_ctrlTreeOptions.GetCheckBox(m_htiUseNAFC, m_bUseNAFC)){
				//m_ctrlTreeOptions.SetCheckBoxEnable(m_htiNAFCAutoLimit, m_bUseNAFC);
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiGiveNAFCFullControl, m_bUseNAFC);
				m_ctrlTreeOptions.SetCheckBoxEnable(m_htiUseDynamicNAFC, m_bUseNAFC);
			}
		}
		*/
//<<< [ionix] - NAFC
		SetModified();
	}
	return 0;
}

void CPPgIonixConnect::OnDestroy()
{
	m_ctrlTreeOptions.DeleteAllItems();
	m_ctrlTreeOptions.DestroyWindow();
	m_bInitializedTreeOpts = false;

	//<<< [ionix] SLUGFILLER: lowIdRetry
	m_htiReconnectOnLowID = NULL;
	//>>> [ionix] SLUGFILLER: lowIdRetry

//>>> [ionix] - Deadlist optional
	m_htiIsUseDeadlist = NULL;
//<<< [ionix] - Deadlist optional

	//<<< [Maella/sivka: -ReAsk SRCs after IP Change-]
	m_htiReaskSrcAfterIpChange = NULL;
	//>>> [Maella/sivka: -ReAsk SRCs after IP Change-]

	// [MoNKi: -UPnPNAT Support-]
	m_htiUPnPRoot = NULL;
	m_htiUPnP = NULL;
	m_htiUPnPWeb = NULL;
	m_htiUPnPTryRandom = NULL; //new upnp - disabled
	// [MoNKi: -UPnPNAT Support-]

	// [MoNKi: -Improved ICS-Firewall support-]
	m_htiICFSupportRoot = NULL;
	m_htiICFSupport = NULL;
	m_htiICFSupportClearAtEnd = NULL;
	// [MoNKi: -Improved ICS-Firewall support-]

	// [MoNKi: -Random Ports-]
	m_htiRandomPortsResetTime = NULL;
	// [MoNKi: -Random Ports-]

	m_htiEnableACC = NULL; //Obelix

//>>> [ionix] - Pawcio: BC
	m_htiSlotGroup = NULL;
	m_htiZZRatio = NULL;
	m_htiMinimizeOpenedSlots = NULL;
	m_htiCumulateBandwidth = NULL;
	m_htiBadwulfsUpload = NULL;
	m_htiPawcioAdvGroup = NULL;
	m_htiManageConn = NULL;
	m_htiIncludeOH = NULL;
	m_htiConnOH = NULL;
	m_htiIncludeTCPAck = NULL;
//<<< [ionix] - Pawcio: BC

//>>> [ionix] - Max ClientUploadrate
	m_htiMaxClientDatarate = NULL;
//<<< [ionix] - Max ClientUploadrate

//>>> WiZaRd::NAFC
	/*
	//m_bNAFCAutoLimit = false;
	m_bUseNAFC = false;
	m_bGiveNAFCFullControl = false;
	m_bUseDynamicNAFC = false;
	m_htiNAFCGroup = NULL;
	//m_htiNAFCAutoLimit = NULL;
	m_htiUseNAFC = NULL;
	m_htiGiveNAFCFullControl = NULL;
	m_htiUseDynamicNAFC = NULL;
	m_htiMinNAFCUpload = NULL;
	m_htiMinNAFCDownload = NULL;
	*/
//<<< WiZaRd::NAFC

	m_htiTimeUp = NULL; // Pawcio: BC
	m_htiTimeDown = NULL; // Pawcio: BC Download

	CPropertyPage::OnDestroy();
}

BOOL CPPgIonixConnect::OnKillActive()
{
	// if prop page is closed by pressing VK_ENTER we have to explicitly commit any possibly pending
	// data from an open edit control
	m_ctrlTreeOptions.HandleChildControlLosingFocus();
	return CPropertyPage::OnKillActive();
}

//>>> [ionix] Fenderman - Spooky Mode [eWombat]
void CPPgIonixConnect::OnSpookyFailedChange()
{	
	GetDlgItem(IDC_SpookyFailedCount)->EnableWindow(IsDlgButtonChecked(IDC_SpookyFailed)!=0); 
	SetModified();
}
//<<< [ionix] Fenderman - Spooky Mode [eWombat]

//>>> WiZaRd: Spooky Mode ConChecker Addon 
void CPPgIonixConnect::OnConCheckerChange()
{	
	if(IsDlgButtonChecked(IDC_GetCheckCon)!=0)
	{
		GetDlgItem(IDC_GetICMP)->EnableWindow(true);
		GetDlgItem(IDC_GetPingTimeout)->EnableWindow(true);
		GetDlgItem(IDC_GetPingTTL)->EnableWindow(true);
	}
	else
	{
		GetDlgItem(IDC_GetICMP)->EnableWindow(false);
		GetDlgItem(IDC_GetPingTimeout)->EnableWindow(false);
		GetDlgItem(IDC_GetPingTTL)->EnableWindow(false);
	}
	SetModified();
}
//<<< WiZaRd: Spooky Mode ConChecker Addon 

//>>> [ionix]: quick start [TPT]
void CPPgIonixConnect::OnBnClickedQuickStart()
{	
	if(IsDlgButtonChecked(IDC_PPG_PHOENIX_QUICKSTART)!=0)
	{
		GetDlgItem(IDS_QUICK_START_MAX_CONN)->EnableWindow(true);
		GetDlgItem(IDS_QUICK_START_MAX_CONN_PER_FIVE)->EnableWindow(true);
		GetDlgItem(IDS_QUICK_START_MINUTES)->EnableWindow(true);
		GetDlgItem(IDC_QUICKSTARTAFTERIPCHANGE)->EnableWindow(true);
	}
	else
	{
		GetDlgItem(IDS_QUICK_START_MAX_CONN)->EnableWindow(false);
		GetDlgItem(IDS_QUICK_START_MAX_CONN_PER_FIVE)->EnableWindow(false);
		GetDlgItem(IDS_QUICK_START_MINUTES)->EnableWindow(false);
		GetDlgItem(IDC_QUICKSTARTAFTERIPCHANGE)->EnableWindow(false);
	}
	SetModified();
}
//<<< [ionix]: quick start [TPT]

//>>> WiZaRd::NAFC
/*
void CPPgIonixConnect::SelectNAFC()
{
	theApp.pNAFC->SelectNAFC();
}
*/
//<<< WiZaRd::NAFC

//>>> [ionix] - ionixguide
void CPPgIonixConnect::OnHelp()
{
	theApp.ShowIonixHelp();
}

BOOL CPPgIonixConnect::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if (wParam == ID_HELP)
	{
		OnHelp();
		return TRUE;
	}
	return __super::OnCommand(wParam, lParam);
}

BOOL CPPgIonixConnect::OnHelpInfo(HELPINFO* pHelpInfo)
{
	OnHelp();
	return TRUE;
}
//<<< [ionix] - ionixguide