#pragma once
#include "TreeOptionsCtrlEx.h"

// CPPgIonixConnect dialog

class CPPgIonixConnect : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgIonixConnect)

public:
	CPPgIonixConnect();
	virtual ~CPPgIonixConnect();

// Dialog Data
	enum { IDD = IDD_PPG_IONIXCONNECT };

	void LoadSettings(void);
	void Localize(void);

protected:
	
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	virtual BOOL OnApply();
	virtual BOOL OnKillActive();

	DECLARE_MESSAGE_MAP()
	afx_msg LRESULT OnTreeOptsCtrlNotify(WPARAM wParam, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnSettingsChange()		{ SetModified(); }
	afx_msg void OnSpookyFailedChange();
	afx_msg void OnConCheckerChange();
//>>> [ionix]: quick start [TPT]
	afx_msg void OnBnClickedQuickStart();
//<<< [ionix]: quick start [TPT]
//>>> WiZaRd::NAFC
	//afx_msg void SelectNAFC();
//<<< WiZaRd::NAFC
protected:
	bool	m_bInitializedTreeOpts;
	CTreeOptionsCtrlEx	m_ctrlTreeOptions;

	bool m_bEnableACC; //Obelix
	int m_iTimeUp; // Pawcio: BC
	int m_iTimeDown; // Pawcio: BC Download

//>>> [ionix] - Pawcio: BC
	bool	m_bZZRatio;
	bool	m_bMinimizeOpenedSlots;
	bool	m_bCumulateBandwidth;
	BOOL	m_bBadwulfsUpload;
	BOOL	m_bManageConn;
	bool	m_bIncludeOH;
	BOOL	m_bConnOH;
	BOOL	m_bIncludeTCPAck;
	HTREEITEM	m_htiSlotGroup;
	HTREEITEM	m_htiPawcioAdvGroup;
	HTREEITEM	m_htiZZRatio;
	HTREEITEM	m_htiMinimizeOpenedSlots;
	HTREEITEM	m_htiCumulateBandwidth;
	HTREEITEM	m_htiBadwulfsUpload;
	HTREEITEM	m_htiManageConn;
	HTREEITEM	m_htiIncludeOH;
	HTREEITEM	m_htiConnOH;
	HTREEITEM	m_htiIncludeTCPAck;
//<<< [ionix] - Pawcio: BC

//>>> [ionix] - Max ClientUploadrate
	HTREEITEM m_htiMaxClientDatarate;
	uint32 m_uMaxClientDatarate;
//<<< [ionix] - Max ClientUploadrate

//>>> WiZaRd::NAFC
/*
public: // [ionix] - changed
	BOOL	m_bUseNAFC;
	HTREEITEM m_htiUseNAFC;
protected:
	//bool	m_bNAFCAutoLimit;
	bool	m_bGiveNAFCFullControl;
	bool	m_bUseDynamicNAFC;
	int		m_uMinNAFCUpload;
	int		m_uMinNAFCDownload;
	HTREEITEM m_htiNAFCGroup;
	//HTREEITEM m_htiNAFCAutoLimit;
	HTREEITEM m_htiGiveNAFCFullControl;
	HTREEITEM m_htiUseDynamicNAFC;
	HTREEITEM m_htiMinNAFCUpload;
	HTREEITEM m_htiMinNAFCDownload;
*/
//<<< WiZaRd::NAFC

	//<<< [ionix] SLUGFILLER: lowIdRetry
	HTREEITEM	m_htiReconnectOnLowID;
	int		m_iReconnectOnLowID;
	//>>> [ionix] SLUGFILLER: lowIdRetry

//>>> [ionix] - Deadlist optional
	HTREEITEM	m_htiIsUseDeadlist;
	bool		m_bIsUseDeadlist;
//<<< [ionix] - Deadlist optional

	//<<< [Maella/sivka: -ReAsk SRCs after IP Change-]
	HTREEITEM	m_htiReaskSrcAfterIpChange;
	BOOL		m_bReaskSrcAfterIpChange;
	//>>> [Maella/sivka: -ReAsk SRCs after IP Change-]

	// [MoNKi: -Random Ports-]
	HTREEITEM	m_htiRandomPortsResetTime;
	int			m_iRandomPortsResetTime;
	// [MoNKi: -Random Ports-]

	// [MoNKi: -UPnPNAT Support-]
	HTREEITEM	m_htiUPnPRoot;
	HTREEITEM	m_htiUPnP;
	HTREEITEM	m_htiUPnPWeb;
	HTREEITEM	m_htiUPnPTryRandom; //new upnp - disabled
	BOOL		m_bUPnP;
	BOOL		m_bUPnPWeb;
	BOOL		m_bUPnPTryRandom; //new upnp - disabled
	// [MoNKi: -UPnPNAT Support-]

	// [MoNKi: -Improved ICS-Firewall support-]
	HTREEITEM	m_htiICFSupportRoot;
	HTREEITEM	m_htiICFSupport;
	HTREEITEM	m_htiICFSupportClearAtEnd;
	HTREEITEM	m_htiICFSupportServerUDP;
	BOOL		m_bICFSupport;
	BOOL		m_bICFSupportClearAtEnd;
	BOOL		m_bICFSupportServerUDP;
	// [MoNKi: -Improved ICS-Firewall support-]

	HTREEITEM m_htiEnableACC; //Obelix
	HTREEITEM m_htiTimeUp; //Pawcio: BC
	HTREEITEM m_htiTimeDown; //Pawcio: BC Download

//>>> [ionix] - ionixguide
protected:
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	afx_msg void OnHelp();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
//<<< [ionix] - ionixguide
};
	