// PPgIonixMisc.cpp : implementation file
#include "stdafx.h"
#include "emule.h"
#include "PPgIonixMisc.h"
#include "XMessageBox.h"
#include "otherfunctions.h"
#include "Preferences.h"
#include "UserMsgs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

// CPPgIonixMisc dialog

IMPLEMENT_DYNAMIC(CPPgIonixMisc, CPropertyPage)
CPPgIonixMisc::CPPgIonixMisc()
	: CPropertyPage(CPPgIonixMisc::IDD)
	, m_ctrlTreeOptions(theApp.m_iDfltImageListColorFlags)
{
	m_bInitializedTreeOpts = false;

	// [ionix] emulate other
	m_htiEmuSettings = NULL;
	m_htiEmuMLDonkey = NULL;
	m_htiEmueDonkey = NULL;
	m_htiEmueDonkeyHybrid = NULL;
	m_bEmuMLDonkey = false;
	m_bEmueDonkey = false;
	m_bEmueDonkeyHybrid = false;
	// [ionix] emulate other

	// Avi3k: ServerFilter
	m_htiSrvFilterPrefs = NULL;
	m_htiSrvFilterAutoDel = NULL;
	m_htiServerFilter = NULL;
	for (int lst=0; lst<9; lst++)
		m_htiSrvFilterList[lst] = NULL;
	m_htiSrvFilterVal = NULL;
	m_htiSrvFilterDataless = NULL;
	m_bSrvFilterAutoDel = 0;
	m_iServerFilter = 0;
	m_sSrvFilterVal = _T("1000");
	m_bSrvFilterDataless = 1;
	// end Avi3k: ServerFilter

	// [ionix] AntiVirus
	m_AntiVirusSettings = NULL;
	m_AntiVirusFileCheck = NULL;
	m_AntiVirusParameter = NULL;
	m_AntiVirusFile = NULL;
	m_bAV = false;
	m_sAVFile.Empty();
	m_sAVParameters.Empty();
	// [ionix] AntiVirus

	//>>> [iONiX] - Multiple Instances
	m_htiMultipleInstances = NULL;
	m_bMultipleInstances = false;
	//<<< [iONiX] - Multiple Instances

	//>>> [ionix]: high process priority - based on MORPH
	m_htiHighProcess = NULL;
	m_htiHighProcessMode_low = NULL;
	m_htiHighProcessMode_lower = NULL;
	m_htiHighProcessMode_normal = NULL;
	m_htiHighProcessMode_higher = NULL;
	m_htiHighProcessMode_high = NULL;
	m_iHighProcessMode = 0;
	//<<< [ionix]: high process priority - based on MORPH

	// [ionix] - emulEspaa [MoNKi: -Automatic shared files updater-]
	m_htiDirectoryWatcher = NULL;
	m_bDirectoryWatcher = false;
	// End -Automatic shared files updater-
}

void CPPgIonixMisc::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_EXT_OPTS, m_ctrlTreeOptions);
	if ( !m_bInitializedTreeOpts )
	{
		int iImgEmuSettings = 8; // default icon
		int iImgServerFilter = 8; // default icon
		int iImgAntiVirus = 8; // default icon
		int iImgProcessPrio = 8; // [ionix] - ProcessPrio
		CImageList* piml = m_ctrlTreeOptions.GetImageList(TVSIL_NORMAL);
		if (piml){
			iImgEmuSettings = piml->Add(CTempIconLoader(_T("EMULATE_SETTINGS_TREE")));
			iImgServerFilter = piml->Add(CTempIconLoader(_T("Server"))); 
			iImgAntiVirus = piml->Add(CTempIconLoader(_T("ANTIVIRUS")));
			iImgProcessPrio = piml->Add(CTempIconLoader(_T("PRIO_AUTO"))); // [ionix] - ProcessPrio
		}

		//>>> [iONiX] - Multiple Instances
		m_htiMultipleInstances = m_ctrlTreeOptions.InsertCheckBox(_T("Multiple Instances"), TVI_ROOT, m_bMultipleInstances);
		//<<< [iONiX] - Multiple Instances

		// [ionix] - emulEspaa [MoNKi: -Automatic shared files updater-]
		m_htiDirectoryWatcher = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_AUTORELOAD_SHAREDFILES), TVI_ROOT, m_bDirectoryWatcher);
		// End -Automatic shared files updater-

		// [ionix] emulate other
		m_htiEmuSettings = m_ctrlTreeOptions.InsertGroup(_T("Emulate Settings"), iImgEmuSettings, TVI_ROOT);
		m_htiEmuMLDonkey = m_ctrlTreeOptions.InsertCheckBox(_T("Emulate MLDonkey"), m_htiEmuSettings, m_bEmuMLDonkey);
		m_htiEmueDonkey = m_ctrlTreeOptions.InsertCheckBox(_T("Emulate eDonkey"), m_htiEmuSettings, m_bEmueDonkey);
		m_htiEmueDonkeyHybrid = m_ctrlTreeOptions.InsertCheckBox(_T("Emulate eDonkeyHybrid"), m_htiEmuSettings, m_bEmueDonkeyHybrid);
		if(m_bEmuMLDonkey || m_bEmueDonkey || m_bEmueDonkeyHybrid)
			m_ctrlTreeOptions.Expand(m_htiEmuSettings, TVE_EXPAND);
		// [ionix]	emulate other

		// Avi3k: ServerFilter
		m_htiSrvFilterPrefs = m_ctrlTreeOptions.InsertGroup(_T("Advanced Server Filter Options"), iImgServerFilter, TVI_ROOT);
		m_htiSrvFilterAutoDel = m_ctrlTreeOptions.InsertCheckBox(_T("Automaticly delete incoming servers"), m_htiSrvFilterPrefs, m_bSrvFilterAutoDel);
		m_htiServerFilter = m_ctrlTreeOptions.InsertGroup(_T("Server Filter"), TREEOPTSCTRLIMG_EDIT, m_htiSrvFilterPrefs);
		m_htiSrvFilterList[0] = m_ctrlTreeOptions.InsertRadioButton(_T("Filter by Ping"), m_htiServerFilter, m_iServerFilter == 0);
		m_htiSrvFilterList[1] = m_ctrlTreeOptions.InsertRadioButton(_T("Filter by No. of Users"), m_htiServerFilter, m_iServerFilter == 1);
		m_htiSrvFilterList[2] = m_ctrlTreeOptions.InsertRadioButton(_T("Filter by Max No. of Users"), m_htiServerFilter, m_iServerFilter == 2);
		m_htiSrvFilterList[3] = m_ctrlTreeOptions.InsertRadioButton(_T("Filter by No. of Files"), m_htiServerFilter, m_iServerFilter == 3);
		m_htiSrvFilterList[4] = m_ctrlTreeOptions.InsertRadioButton(_T("Filter by Hard Limit"), m_htiServerFilter, m_iServerFilter == 4);
		m_htiSrvFilterList[5] = m_ctrlTreeOptions.InsertRadioButton(_T("Filter by Soft Limit"), m_htiServerFilter, m_iServerFilter == 5);
		m_htiSrvFilterList[6] = m_ctrlTreeOptions.InsertRadioButton(_T("Filter Failed servers"), m_htiServerFilter, m_iServerFilter == 6);
		m_htiSrvFilterList[7] = m_ctrlTreeOptions.InsertRadioButton(_T("Filter by Server Name"), m_htiServerFilter, m_iServerFilter == 7);
		m_htiSrvFilterList[8] = m_ctrlTreeOptions.InsertRadioButton(_T("Filter by Description"), m_htiServerFilter, m_iServerFilter == 8);
		m_htiSrvFilterVal = m_ctrlTreeOptions.InsertItem(_T("Filter value"), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiSrvFilterPrefs);
		m_ctrlTreeOptions.AddEditBox(m_htiSrvFilterVal, RUNTIME_CLASS(CTreeOptionsEdit));
		m_htiSrvFilterDataless = m_ctrlTreeOptions.InsertCheckBox(_T("Delete dataless servers (with zero value)"), m_htiSrvFilterPrefs, m_bSrvFilterDataless);
		//m_ctrlTreeOptions.Expand(m_htiSrvFilterPrefs, TVE_EXPAND);
		// end Avi3k: ServerFilter

		// [ionix] AntiVirus
		m_AntiVirusSettings = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_ANTIVIRUS), iImgAntiVirus, TVI_ROOT); // , TVI_ROOT);//
		m_AntiVirusFileCheck = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_ANTIVIRUS_CHECK), m_AntiVirusSettings, m_bAV);
		m_AntiVirusFile = m_ctrlTreeOptions.InsertItem(GetResString(IDS_ANTIVIRUS_FILE), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT,m_AntiVirusSettings);
		m_ctrlTreeOptions.AddFileEditBox(m_AntiVirusFile,  RUNTIME_CLASS(CTreeOptionsEdit),  RUNTIME_CLASS(CTreeOptionsBrowseButton));
		m_AntiVirusParameter = m_ctrlTreeOptions.InsertItem(GetResString(IDS_ANTIVIRUS_INPUT_PARAMETER),TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_AntiVirusSettings);
		m_ctrlTreeOptions.AddEditBox(m_AntiVirusParameter, RUNTIME_CLASS(CTreeOptionsEdit));
		if(m_bAV)
			m_ctrlTreeOptions.Expand(m_AntiVirusSettings, TVE_EXPAND);
		// [ionix] AntiVirus	

		//>>> [ionix]: high process priority - based on MORPH
		WORD wWinVer = thePrefs.GetWindowsVersion();	// maybe causes problems on 98 & nt4
		bool bW2kHigher = true;
		if(wWinVer == _WINVER_95_ || wWinVer == _WINVER_98_ || wWinVer == _WINVER_ME_ || wWinVer == _WINVER_NT4_)	
			bW2kHigher = false;
		m_htiHighProcess = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_HIGHPROCESS), iImgProcessPrio, TVI_ROOT);
		m_htiHighProcessMode_low = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_LOW_PROCESS), m_htiHighProcess, m_iHighProcessMode == 0);
		if(bW2kHigher) // not supported in < W2k
			m_htiHighProcessMode_lower = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_LOWER_PROCESS), m_htiHighProcess, m_iHighProcessMode == 1);
		m_htiHighProcessMode_normal = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_NORMAL_PROCESS), m_htiHighProcess, m_iHighProcessMode == 2);
		if(bW2kHigher) // not supported in < W2k
			m_htiHighProcessMode_higher = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_HIGHER_PROCESS), m_htiHighProcess, m_iHighProcessMode == 3);
		m_htiHighProcessMode_high = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_HIGH_PROCESS), m_htiHighProcess, m_iHighProcessMode == 4);
		m_ctrlTreeOptions.Expand(m_htiHighProcess, TVE_EXPAND);
		//<<< [ionix]: high process priority - based on MORPH

		if (thePrefs.ServerFilterAutoDel) // Avi3k: ServerFilter
		{
			m_ctrlTreeOptions.Expand(m_htiSrvFilterPrefs, TVE_EXPAND);
			m_ctrlTreeOptions.Expand(m_htiServerFilter, TVE_EXPAND);
		}

		m_ctrlTreeOptions.SelectItem(m_ctrlTreeOptions.GetRootItem());
		m_bInitializedTreeOpts = true;
	}

	//>>> [iONiX] - Multiple Instances
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiMultipleInstances, m_bMultipleInstances);
	//<<< [iONiX] - Multiple Instances

	// [ionix] - emulEspaa [MoNKi: -Automatic shared files updater-]
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiDirectoryWatcher, m_bDirectoryWatcher);
	// End -Automatic shared files updater-

	// [ionix] emulate other
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiEmuMLDonkey, m_bEmuMLDonkey);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiEmueDonkey, m_bEmueDonkey);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiEmueDonkeyHybrid, m_bEmueDonkeyHybrid);
	// [ionix] emulate other

	// Avi3k: ServerFilter
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiSrvFilterAutoDel, m_bSrvFilterAutoDel);
	DDX_TreeRadio(pDX, IDC_EXT_OPTS, m_htiServerFilter, m_iServerFilter);
	DDX_Text(pDX, IDC_EXT_OPTS, m_htiSrvFilterVal, m_sSrvFilterVal);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiSrvFilterDataless, m_bSrvFilterDataless);
	// end Avi3k: ServerFilter

	// [ionix] AntiVirus
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_AntiVirusFileCheck, m_bAV);
	DDX_TreeFileEdit(pDX, IDC_EXT_OPTS, m_AntiVirusFile, m_sAVFile);
	DDV_MaxChars(pDX,m_sAVFile, 500);
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_AntiVirusParameter, m_sAVParameters);
	// [ionix] AntiVirus

	//>>> [ionix]: high process priority - based on MORPH
	DDX_TreeRadio(pDX, IDC_EXT_OPTS, m_htiHighProcess, m_iHighProcessMode);
	//>>> [ionix]: high process priority - based on MORPH
}

BEGIN_MESSAGE_MAP(CPPgIonixMisc, CPropertyPage)
	ON_WM_HSCROLL()	// [ionix] - NiceHash
	//[ionix] - Invisible Mode - Start 
	ON_CBN_SELCHANGE(IDC_INVISIBLE_MODE_SELECT_COMBO, OnSettingsChange) 
	ON_CBN_SELCHANGE(IDC_INVISIBLE_MODE_KEY_COMBO, OnCbnSelchangeKeymodcombo) 
	ON_BN_CLICKED(IDC_INVISIBLE_MODE, OnBoxesChange) 
	ON_BN_CLICKED(IDC_INVISIBLE_ONSTART, OnBoxesChange)	//>>> [ionix] - StartUp InvisibleMode Enhancement
	//[ionix] - Invisible Mode - End 
	//[ionix] End -, TBH-AutoBackup
	ON_BN_CLICKED(IDC_BACKUPNOW, OnBnClickedBackupnow)
	ON_BN_CLICKED(IDC_DAT, OnBnClickedDat)
	ON_BN_CLICKED(IDC_MET, OnBnClickedMet)
	ON_BN_CLICKED(IDC_INI, OnBnClickedIni)
	ON_BN_CLICKED(IDC_PART, OnBnClickedPart)
	ON_BN_CLICKED(IDC_PARTMET, OnBnClickedPartMet)
	ON_BN_CLICKED(IDC_SELECTALL, OnBnClickedSelectall)
	ON_BN_CLICKED(IDC_AUTOBACKUP, OnSettingsChange)
	ON_BN_CLICKED(IDC_AUTOBACKUP2, OnSettingsChange) // Double Backup
	//[ionix] End -, TBH-AutoBackup
	//[ionix]- BEGIN - enkeyDEV(kei-kun) -SLS preferences- //
	ON_BN_CLICKED(IDC_SLS_USESLS, OnBnClickedusesls)
	ON_EN_CHANGE(IDC_SLS_NUMBER, OnSettingsChange)
	ON_EN_CHANGE(IDC_SLS_LIMIT, OnSettingsChange)
	//[ionix]- BEGIN - enkeyDEV(kei-kun) -SLS preferences- //
	ON_MESSAGE(UM_TREEOPTSCTRL_NOTIFY, OnTreeOptsCtrlNotify)
	ON_WM_HELPINFO() //<<< [ionix] - ionixguide
	ON_WM_DESTROY()
END_MESSAGE_MAP()

BOOL CPPgIonixMisc::OnInitDialog()
{
	//[ionix] - Invisible Mode - Start 
	// Add keys to ComboBox 
	for(int i='A'; i<='Z'; i++) 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_SELECT_COMBO))->AddString(CString((TCHAR)(i))); 
	for(int i='0'; i<='9'; i++) 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_SELECT_COMBO))->AddString(CString((TCHAR)(i))); 
	//[ionix] - Invisible Mode - End 

	//[ionix]- BEGIN - enkeyDEV(kei-kun) -SLS preferences- //
	((CEdit*)GetDlgItem(IDC_SLS_LIMIT))->SetLimitText(3); 
	((CEdit*)GetDlgItem(IDC_SLS_NUMBER))->SetLimitText(2);
	//[ionix]- BEGIN - enkeyDEV(kei-kun) -SLS preferences- //

	// [ionix] emulate other
	m_bEmuMLDonkey = thePrefs.EmuMLDonkey;
	m_bEmueDonkey = thePrefs.EmueDonkey;
	m_bEmueDonkeyHybrid = thePrefs.EmueDonkeyHybrid;
	// [ionix] emulate other

	// Avi3k: ServerFilter
	m_bSrvFilterAutoDel = thePrefs.ServerFilterAutoDel;
	m_iServerFilter = thePrefs.ServerFilter;
	m_sSrvFilterVal = thePrefs.GetServerFilterVal();
	m_bSrvFilterDataless = thePrefs.ServerFilterDataless;
	// end Avi3k: ServerFilter

	// [ionix] AntiVirus
	m_sAVParameters = thePrefs.m_aVParameter;
	m_sAVFile = thePrefs.m_aVFilename;
	m_bAV = thePrefs.m_aVCheck;;
	// [ionix] AntiVirus

	//>>> [iONiX] - Multiple Instances
	m_bMultipleInstances = thePrefs.GetAllowMultipleInstances();
	//<<< [iONiX] - Multiple Instances

	//>>> [ionix]: high process priority - based on MORPH
	m_iHighProcessMode = thePrefs.GetProcessPrio();
	//>>> [ionix]: high process priority - based on MORPH

	// [ionix] - emulEspaa [MoNKi: -Automatic shared files updater-]
	m_bDirectoryWatcher = thePrefs.GetDirectoryWatcher();
	// End -Automatic shared files updater-

	CPropertyPage::OnInitDialog();
	InitWindowStyles(this);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgIonixMisc::LoadSettings(void){

	if(m_hWnd)
	{
		CString strBuffer;

		//[ionix] - Invisible Mode - Start 
		m_iActualKeyModifier = thePrefs.GetInvisibleModeHKKeyModifier(); 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_SELECT_COMBO))->SelectString(-1, CString(thePrefs.GetInvisibleModeHKKey())); 
		if (!thePrefs.GetInvisibleMode()){ 
			GetDlgItem(IDC_INVISIBLE_MODE_SELECT_STATIC)->EnableWindow(false); 
			GetDlgItem(IDC_INVISIBLE_MODE_MODIFIER_STATIC)->EnableWindow(false); 
			GetDlgItem(IDC_INVISIBLE_MODE_KEY_STATIC)->EnableWindow(false); 
			GetDlgItem(IDC_INVISIBLE_MODE_SYMBOL_STATIC)->EnableWindow(false); 
			GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO)->EnableWindow(false); 
			GetDlgItem(IDC_INVISIBLE_MODE_SELECT_COMBO)->EnableWindow(false); 
			CheckDlgButton(IDC_INVISIBLE_MODE, 0); 
			//>>> [ionix] - StartUp InvisibleMode Enhancement
			GetDlgItem(IDC_INVISIBLE_ONSTART)->EnableWindow(false); 
			//>>> [ionix] - StartUp InvisibleMode Enhancement
		} else 
			CheckDlgButton(IDC_INVISIBLE_MODE, 1); 
		//[ionix] - Invisible Mode - End 

		//>>> [ionix] - StartUp InvisibleMode Enhancement
		CheckDlgButton(IDC_INVISIBLE_ONSTART, thePrefs.IsStartInvisible());
		//>>> [ionix] - StartUp InvisibleMode Enhancement

		//[ionix] Start, TBH-AutoBackup
		CheckDlgButton(IDC_AUTOBACKUP, thePrefs.GetAutoBackup());
		//[ionix] Start, TBH-AutoBackup

		//[ionix] Start -, Double Backup
		CheckDlgButton(IDC_AUTOBACKUP2, thePrefs.GetAutoBackup2());
		//[ionix] End -, Double Backup

		//[ionix]- END - enkeyDEV(kei-kun) -SLS preferences- //
		GetDlgItem(IDC_SLS_LIMIT)->EnableWindow(thePrefs.UseSaveLoadSources()); 
		GetDlgItem(IDC_SLS_NUMBER)->EnableWindow(thePrefs.UseSaveLoadSources()); 

		strBuffer.Format(_T("%d"), thePrefs.GetActivationLimitSLS()); 
		GetDlgItem(IDC_SLS_LIMIT)->SetWindowText(strBuffer); 
		strBuffer.Format(_T("%d"), thePrefs.GetSourcesToSaveSLS());
		GetDlgItem(IDC_SLS_NUMBER)->SetWindowText(strBuffer);
		CheckDlgButton(IDC_SLS_USESLS, thePrefs.UseSaveLoadSources()); 
		//[ionix]- END - enkeyDEV(kei-kun) -SLS preferences- //
	}
}

BOOL CPPgIonixMisc::OnApply()
{
	CString sBuffer;

	//[ionix] - Invisible Mode - Start 
	CString sKey; 
	// First check if we have a value
	if(((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_SELECT_COMBO))->GetCurSel() >= 0)
	{
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_SELECT_COMBO))->GetLBText(((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_SELECT_COMBO))->GetCurSel(), sKey); 
		thePrefs.SetInvisibleMode(IsDlgButtonChecked(IDC_INVISIBLE_MODE)!=0,m_iActualKeyModifier,sKey[0]); 
	}
	else
		thePrefs.SetInvisibleMode(false,m_iActualKeyModifier,NULL);
	//[ionix] - Invisible Mode - End 

	//>>> [ionix] - StartUp InvisibleMode Enhancement
	thePrefs.m_bStartInvisible = IsDlgButtonChecked(IDC_INVISIBLE_ONSTART)!=0;
	//>>> [ionix] - StartUp InvisibleMode Enhancement

	// [ionix] Start, TBH-AutoBackup
	thePrefs.autobackup = IsDlgButtonChecked(IDC_AUTOBACKUP)!=0;
	// [ionix] Start, TBH-AutoBackup

	// [ionix] Start - Double Backup
	thePrefs.autobackup2 = IsDlgButtonChecked(IDC_AUTOBACKUP2)!=0;
	// [ionix] Start - Double Backup

	// [ionix] WiZaRd - START - enkeyDEV(kei-kun) -SLS preferences- //
	GetDlgItem(IDC_SLS_NUMBER)->GetWindowText(sBuffer); 
	thePrefs.m_iSourcesToSaveSLS = _tstoi(sBuffer)>25?25:_tstoi(sBuffer);

	GetDlgItem(IDC_SLS_LIMIT)->GetWindowText(sBuffer); 
	thePrefs.m_iActivationLimitSLS = _tstoi(sBuffer)>200?200:_tstoi(sBuffer);;

	thePrefs.m_bUseSaveLoadSources = IsDlgButtonChecked(IDC_SLS_USESLS)!=0;
	// [ionix] WiZaRd - END - enkeyDEV(kei-kun) -SLS preferences- //

	// [ionix] emulate other
	thePrefs.EmuMLDonkey = m_bEmuMLDonkey;
	thePrefs.EmueDonkey = m_bEmueDonkey;
	thePrefs.EmueDonkeyHybrid = m_bEmueDonkeyHybrid;
	// [ionix] emulate other

	// Avi3k: ServerFilter
	thePrefs.ServerFilterAutoDel = m_bSrvFilterAutoDel;
	thePrefs.ServerFilter = m_iServerFilter;
	sprintf(thePrefs.ServerFilterVal,"%s",m_sSrvFilterVal);
	thePrefs.ServerFilterDataless = m_bSrvFilterDataless;
	// end Avi3k: ServerFilter

	// [ionix] AntiVirus
	_tcsncpy(thePrefs.m_aVParameter, m_sAVParameters.GetBuffer(),250);
	thePrefs.m_aVParameter[250]=0;
	_tcsncpy(thePrefs.m_aVFilename, m_sAVFile.GetBuffer(),500);
	thePrefs.m_aVFilename[500]=0;
	thePrefs.m_aVCheck = m_bAV;
	// [ionix] AntiVirus

	//>>> [iONiX] - Multiple Instances
	thePrefs.m_bAllowMultipleInstances = m_bMultipleInstances;
	//<<< [iONiX] - Multiple Instances

	//>>> [ionix]: high process priority - based on MORPH
	thePrefs.SetProcessPrio(m_iHighProcessMode);
	//>>> [ionix]: high process priority - based on MORPH

	// [ionix] - emulEspaa [MoNKi: -Automatic shared files updater-]
	if(m_bDirectoryWatcher != thePrefs.GetDirectoryWatcher()){
		thePrefs.SetDirectoryWatcher(m_bDirectoryWatcher);
		theApp.ResetDirectoryWatcher();
	}
	// End -Automatic shared files updater-

	SetModified(FALSE);

	LoadSettings();
	return CPropertyPage::OnApply();
}

void CPPgIonixMisc::Localize(void)
{
	if(m_hWnd)
	{
		//[ionix] - Invisible Mode - Start
		// Add key modifiers to ComboBox 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->ResetContent(); 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->AddString(GetResString(IDS_CTRLKEY)); 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->AddString(GetResString(IDS_ALTKEY)); 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->AddString(GetResString(IDS_SHIFTKEY)); 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->AddString(GetResString(IDS_CTRLKEY) + _T(" + ") + GetResString(IDS_ALTKEY)); 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->AddString(GetResString(IDS_CTRLKEY) + _T(" + ") + GetResString(IDS_SHIFTKEY)); 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->AddString(GetResString(IDS_ALTKEY) + _T(" + ") + GetResString(IDS_SHIFTKEY)); 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->AddString(GetResString(IDS_CTRLKEY) + _T(" + ") + GetResString(IDS_ALTKEY) + _T(" + ") + GetResString(IDS_SHIFTKEY)); 

		CString key_modifier; 
		if (m_iActualKeyModifier & MOD_CONTROL) 
			key_modifier=GetResString(IDS_CTRLKEY); 
		if (m_iActualKeyModifier & MOD_ALT){ 
			if (!key_modifier.IsEmpty()) key_modifier += " + "; 
			key_modifier+=GetResString(IDS_ALTKEY); 
		} 
		if (m_iActualKeyModifier & MOD_SHIFT){ 
			if (!key_modifier.IsEmpty()) key_modifier += " + "; 
			key_modifier+=GetResString(IDS_SHIFTKEY); 
		} 
		((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->SelectString(-1,key_modifier); 

		GetDlgItem(IDC_INVISIBLE_MODE_GROUP_BOX)->SetWindowText(GetResString(IDS_INVMODE_GROUP)); 
		GetDlgItem(IDC_INVISIBLE_MODE)->SetWindowText(GetResString(IDS_INVMODE)); 
		GetDlgItem(IDC_INVISIBLE_MODE_SELECT_STATIC)->SetWindowText(GetResString(IDS_INVMODE_HOTKEY)); 
		GetDlgItem(IDC_INVISIBLE_MODE_MODIFIER_STATIC)->SetWindowText(GetResString(IDS_INVMODE_MODKEY)); 
		GetDlgItem(IDC_INVISIBLE_MODE_KEY_STATIC)->SetWindowText(GetResString(IDS_INVMODE_VKEY)); 
        //[ionix] - Invisible Mode - End 
		//>>> [ionix] - StartUp InvisibleMode Enhancement
		GetDlgItem(IDC_INVISIBLE_ONSTART)->SetWindowText(GetResString(IDS_INVMODE_ONSTART)); 
		//>>> [ionix] - StartUp InvisibleMode Enhancement
		GetDlgItem(IDC_BACKUP_FILEFRAME)->SetWindowText(GetResString(IDS_BACKUP_FILEFRAME));
		GetDlgItem(IDC_SELECTALL)->SetWindowText(GetResString(IDS_SELECTALL));
		GetDlgItem(IDC_BACKUPNOW)->SetWindowText(GetResString(IDS_BACKUPNOW));
		GetDlgItem(IDC_AUTOBACKUP2)->SetWindowText(GetResString(IDS_AUTOBACKUP2));
		GetDlgItem(IDC_BACKUP_AUTO)->SetWindowText(GetResString(IDS_BACKUP_AUTO));
		GetDlgItem(IDC_AUTOBACKUP)->SetWindowText(GetResString(IDS_AUTOBACKUP));
		GetDlgItem(IDC_GB_SLS)->SetWindowText(GetResString(IDS_GB_SLS));
		GetDlgItem(IDC_SLS_USESLS)->SetWindowText(GetResString(IDS_SLS_USESLS));
		GetDlgItem(IDC_SLS_NUMBER_STATIC)->SetWindowText(GetResString(IDS_SLS_NUMBER_STATIC));
		GetDlgItem(IDC_SLS_LIMIT_STATIC)->SetWindowText(GetResString(IDS_SLS_LIMIT_STATIC));

		//>>> [iONiX] - Multiple Instances
		if(m_htiMultipleInstances) m_ctrlTreeOptions.SetItemText(m_htiMultipleInstances, GetResString(IDS_MULTIPLE_EMULE));
		//<<< [iONiX] - Multiple Instances

		// [ionix] emulate other
		if (m_htiEmuSettings) m_ctrlTreeOptions.SetItemText(m_htiEmuSettings, GetResString(IDS_EMUSETTINGS));
		if (m_htiEmuMLDonkey) m_ctrlTreeOptions.SetItemText(m_htiEmuMLDonkey, GetResString(IDS_EMUML));
		if (m_htiEmueDonkey) m_ctrlTreeOptions.SetItemText(m_htiEmueDonkey, GetResString(IDS_EMUDONKEY));
		if (m_htiEmueDonkeyHybrid) m_ctrlTreeOptions.SetItemText(m_htiEmueDonkeyHybrid, GetResString(IDS_EMUHYBRID));
		// [ionix] emulate other

		// Avi3k: ServerFilter
		if (m_htiSrvFilterPrefs) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterPrefs, GetResString(IDS_SRVFILTER_PREFS));
		if (m_htiSrvFilterAutoDel) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterAutoDel, GetResString(IDS_SRVFILTER_AUTODEL));
		if (m_htiServerFilter) m_ctrlTreeOptions.SetItemText(m_htiServerFilter, GetResString(IDS_SRVFILTER_LABEL));
		if (m_htiSrvFilterList[0]) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterList[0], GetResString(IDS_SRVFILTER_PING));
		if (m_htiSrvFilterList[1]) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterList[1], GetResString(IDS_SRVFILTER_USERS));
		if (m_htiSrvFilterList[2]) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterList[2], GetResString(IDS_SRVFILTER_MUSERS));
		if (m_htiSrvFilterList[3]) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterList[3], GetResString(IDS_SRVFILTER_FILES));
		if (m_htiSrvFilterList[4]) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterList[4], GetResString(IDS_SRVFILTER_HLIMIT));
		if (m_htiSrvFilterList[5]) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterList[5], GetResString(IDS_SRVFILTER_SLIMIT));
		if (m_htiSrvFilterList[6]) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterList[6], GetResString(IDS_SRVFILTER_FAILED));
		if (m_htiSrvFilterList[7]) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterList[7], GetResString(IDS_SRVFILTER_NAME));
		if (m_htiSrvFilterList[8]) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterList[8], GetResString(IDS_SRVFILTER_DESC));
		if (m_htiSrvFilterVal) m_ctrlTreeOptions.SetEditLabel(m_htiSrvFilterVal, GetResString(IDS_SRVFILTER_VALUE));
		if (m_htiSrvFilterDataless) m_ctrlTreeOptions.SetItemText(m_htiSrvFilterDataless, GetResString(IDS_SRVFILTER_DATALESS));
		// end Avi3k: ServerFilter

		// [ionix] AntiVirus
		if (m_AntiVirusSettings) m_ctrlTreeOptions.SetItemText(m_AntiVirusSettings, GetResString(IDS_ANTIVIRUS));
		if (m_AntiVirusFileCheck) m_ctrlTreeOptions.SetItemText(m_AntiVirusFileCheck, GetResString(IDS_ANTIVIRUS_CHECK));
		if (m_AntiVirusFile) m_ctrlTreeOptions.SetEditLabel(m_AntiVirusFile, GetResString(IDS_ANTIVIRUS_FILE));
		if (m_AntiVirusParameter) m_ctrlTreeOptions.SetEditLabel(m_AntiVirusParameter, GetResString(IDS_ANTIVIRUS_INPUT_PARAMETER));
		// [ionix] AntiVirus

		//>>> [ionix]: high process priority - based on MORPH
		if (m_htiHighProcess) m_ctrlTreeOptions.SetItemText(m_htiHighProcess, GetResString(IDS_HIGHPROCESS));
		if (m_htiHighProcessMode_low) m_ctrlTreeOptions.SetItemText(m_htiHighProcessMode_low, GetResString(IDS_LOW_PROCESS));
		if (m_htiHighProcessMode_lower) m_ctrlTreeOptions.SetItemText(m_htiHighProcessMode_lower, GetResString(IDS_LOWER_PROCESS));
		if (m_htiHighProcessMode_normal) m_ctrlTreeOptions.SetItemText(m_htiHighProcessMode_normal, GetResString(IDS_NORMAL_PROCESS));
		if (m_htiHighProcessMode_higher) m_ctrlTreeOptions.SetItemText(m_htiHighProcessMode_higher, GetResString(IDS_HIGHER_PROCESS));
		if (m_htiHighProcessMode_high) m_ctrlTreeOptions.SetItemText(m_htiHighProcessMode_high, GetResString(IDS_HIGH_PROCESS));
		//<<< [ionix]: high process priority - based on MORPH
		// [ionix] - emulEspaa [MoNKi: -Automatic shared files updater-]
		if(m_htiDirectoryWatcher) m_ctrlTreeOptions.SetItemText(m_htiDirectoryWatcher, GetResString(IDS_AUTORELOAD_SHAREDFILES));
		// End -Automatic shared files updater-
	}
}

CPPgIonixMisc::~CPPgIonixMisc(void)
{
}

void CPPgIonixMisc::OnDestroy()
{
	m_ctrlTreeOptions.DeleteAllItems();
	m_ctrlTreeOptions.DestroyWindow();
	m_bInitializedTreeOpts = false;

	//>>> [iONiX] - Multiple Instances
	m_htiMultipleInstances = NULL;
	//<<< [iONiX] - Multiple Instances

	// [ionix] emulate other
	m_htiEmuSettings = NULL;
	m_htiEmuMLDonkey = NULL;
	m_htiEmueDonkey = NULL;
	m_htiEmueDonkeyHybrid = NULL;
	// [ionix] emulate other

	// Avi3k: ServerFilter
	m_htiSrvFilterPrefs = NULL;
	m_htiSrvFilterAutoDel = NULL;
	m_htiServerFilter = NULL;
	for (int lst=0; lst<9; lst++)
		m_htiSrvFilterList[lst] = NULL;
	m_htiSrvFilterVal = NULL;
	m_htiSrvFilterDataless = NULL;
	// end Avi3k: ServerFilter

	// [ionix] AntiVirus
	m_AntiVirusSettings = NULL;
	m_AntiVirusFileCheck = NULL;
	m_AntiVirusParameter = NULL;
	m_AntiVirusFile = NULL;
	// [ionix] AntiVirus

	//>>> [ionix]: high process priority - based on MORPH
	m_htiHighProcess = NULL;
	m_htiHighProcessMode_low = NULL;
	m_htiHighProcessMode_lower = NULL;
	m_htiHighProcessMode_normal = NULL;
	m_htiHighProcessMode_higher = NULL;
	m_htiHighProcessMode_high = NULL;
	//<<< [ionix]: high process priority - based on MORPH

	// [ionix] - emulEspaa [MoNKi: -Automatic shared files updater-]
	m_htiDirectoryWatcher = NULL;
	// End -Automatic shared files updater-

	CPropertyPage::OnDestroy();
}

BOOL CPPgIonixMisc::OnKillActive()
{
	// if prop page is closed by pressing VK_ENTER we have to explicitly commit any possibly pending
	// data from an open edit control
	m_ctrlTreeOptions.HandleChildControlLosingFocus();
	return CPropertyPage::OnKillActive();
}

LRESULT CPPgIonixMisc::OnTreeOptsCtrlNotify(WPARAM wParam, LPARAM lParam)
{
	if (wParam == IDC_EXT_OPTS)
		SetModified();
	return 0;
}

//[ionix] - Invisible Mode - Start  
void CPPgIonixMisc::SetBoxes() 
{     
	bool bImode = IsDlgButtonChecked(IDC_INVISIBLE_MODE)!=0; 

	GetDlgItem(IDC_INVISIBLE_MODE_SELECT_STATIC)->EnableWindow(bImode); 
	GetDlgItem(IDC_INVISIBLE_MODE_MODIFIER_STATIC)->EnableWindow(bImode); 
	GetDlgItem(IDC_INVISIBLE_MODE_KEY_STATIC)->EnableWindow(bImode); 
	GetDlgItem(IDC_INVISIBLE_MODE_SYMBOL_STATIC)->EnableWindow(bImode); 
	GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO)->EnableWindow(bImode); 
	GetDlgItem(IDC_INVISIBLE_MODE_SELECT_COMBO)->EnableWindow(bImode); 
	//>>> [ionix] - StartUp InvisibleMode Enhancement
	GetDlgItem(IDC_INVISIBLE_ONSTART)->EnableWindow(bImode); 
	//>>> [ionix] - StartUp InvisibleMode Enhancement

	SetModified(); 
} 

void CPPgIonixMisc::OnCbnSelchangeKeymodcombo() 
{ 
	CString sKeyMod; 

	((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->GetLBText(((CComboBox*)GetDlgItem(IDC_INVISIBLE_MODE_KEY_COMBO))->GetCurSel(), sKeyMod); 
	m_iActualKeyModifier = 0; 
	if (sKeyMod.Find(GetResString(IDS_CTRLKEY))!=-1) 
		m_iActualKeyModifier |= MOD_CONTROL; 
	if (sKeyMod.Find(GetResString(IDS_ALTKEY))!=-1) 
		m_iActualKeyModifier |= MOD_ALT; 
	if (sKeyMod.Find(GetResString(IDS_SHIFTKEY))!=-1) 
		m_iActualKeyModifier |= MOD_SHIFT; 

	SetModified(); 
} 
//[ionix] - Invisible Mode - End 

void CPPgIonixMisc::OnBnClickedDat()
{
	if (IsDlgButtonChecked(IDC_DAT)!=0) 
		GetDlgItem(IDC_BACKUPNOW)->EnableWindow(IsDlgButtonChecked(IDC_DAT)!=0);
	 else if (!IsDlgButtonChecked(IDC_DAT)!=0 
		 && !IsDlgButtonChecked(IDC_MET)!=0 
		 && !IsDlgButtonChecked(IDC_INI)!=0 
		 && !IsDlgButtonChecked(IDC_PART)!=0 
		 && !IsDlgButtonChecked(IDC_PARTMET)!=0)
		GetDlgItem(IDC_BACKUPNOW)->EnableWindow(false);
}

void CPPgIonixMisc::OnBnClickedMet()
{
	if (IsDlgButtonChecked(IDC_MET)!=0) 
		GetDlgItem(IDC_BACKUPNOW)->EnableWindow(IsDlgButtonChecked(IDC_MET)!=0);
	else if (!IsDlgButtonChecked(IDC_DAT)!=0
		&& !IsDlgButtonChecked(IDC_MET)!=0
		&& !IsDlgButtonChecked(IDC_INI)!=0
		&& !IsDlgButtonChecked(IDC_PART)!=0
		&& !IsDlgButtonChecked(IDC_PARTMET)!=0)
		GetDlgItem(IDC_BACKUPNOW)->EnableWindow(false);
}

void CPPgIonixMisc::OnBnClickedIni()
{
	if (IsDlgButtonChecked(IDC_INI)) 
		GetDlgItem(IDC_BACKUPNOW)->EnableWindow(IsDlgButtonChecked(IDC_INI));
	else if (!IsDlgButtonChecked(IDC_DAT) && !IsDlgButtonChecked(IDC_MET) && !IsDlgButtonChecked(IDC_INI) && !IsDlgButtonChecked(IDC_PART) && !IsDlgButtonChecked(IDC_PARTMET))
		GetDlgItem(IDC_BACKUPNOW)->EnableWindow(false);
}

void CPPgIonixMisc::OnBnClickedPart()
{
	if (IsDlgButtonChecked(IDC_PART)) 
		GetDlgItem(IDC_BACKUPNOW)->EnableWindow(IsDlgButtonChecked(IDC_PART));
	else if (!IsDlgButtonChecked(IDC_DAT) && !IsDlgButtonChecked(IDC_MET) && !IsDlgButtonChecked(IDC_INI) && !IsDlgButtonChecked(IDC_PART) && !IsDlgButtonChecked(IDC_PARTMET))
		GetDlgItem(IDC_BACKUPNOW)->EnableWindow(false);
}

void CPPgIonixMisc::OnBnClickedPartMet()
{
	if (IsDlgButtonChecked(IDC_PARTMET)) 
		GetDlgItem(IDC_BACKUPNOW)->EnableWindow(IsDlgButtonChecked(IDC_PARTMET));
	else if (!IsDlgButtonChecked(IDC_DAT) && !IsDlgButtonChecked(IDC_MET) && !IsDlgButtonChecked(IDC_INI) && !IsDlgButtonChecked(IDC_PART) && !IsDlgButtonChecked(IDC_PARTMET))
		GetDlgItem(IDC_BACKUPNOW)->EnableWindow(false);
}

void CPPgIonixMisc::OnBnClickedBackupnow()
{
	TCHAR buffer[200];
	y2All = FALSE;
	if (IsDlgButtonChecked(IDC_DAT))
	{
		Backup(_T("*.dat"), true);
		CheckDlgButton(IDC_DAT,BST_UNCHECKED);
	}

	if (IsDlgButtonChecked(IDC_MET))
	{
		Backup(_T("*.met"), true);
		CheckDlgButton(IDC_MET,BST_UNCHECKED);
	}

	if (IsDlgButtonChecked(IDC_INI))
	{
		Backup(_T("*.ini"), true);
		CheckDlgButton(IDC_INI,BST_UNCHECKED);
	}

	if (IsDlgButtonChecked(IDC_PARTMET))
	{
		Backup2(_T("*.part.met"));
		CheckDlgButton(IDC_PARTMET,BST_UNCHECKED);
	}

	if (IsDlgButtonChecked(IDC_PART))
	{
		_stprintf(buffer,_T("Because of their size, backing up *.part files may take a few minutes.\nAre you sure you want to do this?"));
		if(MessageBox(buffer,_T("Are you sure?"),MB_ICONQUESTION|MB_YESNO)== IDYES)
			Backup2(_T("*.part"));
		CheckDlgButton(IDC_PART,BST_UNCHECKED);

	}

	MessageBox(_T("File(s) Copied Successfully."), _T("BackUp complete."), MB_OK);
	y2All = FALSE;
}

void CPPgIonixMisc::Backup(LPCTSTR extensionToBack, BOOL conFirm)  
{
	WIN32_FIND_DATA FileData; 
	HANDLE hSearch; 
	TCHAR buffer[200];
	//CString szDirPath = CString(thePrefs.GetAppDir());
	CString szDirPath = CString(thePrefs.GetConfigDir());
	TCHAR szNewPath[MAX_PATH]; 

	SetCurrentDirectory(szDirPath);
	BOOL error = FALSE;
	BOOL OverWrite = TRUE;
	szDirPath +="Backup\\";

	BOOL fFinished = FALSE; 

	// Create a new directory if one does not exist
	if(!PathFileExists(szDirPath))
		CreateDirectory(szDirPath, NULL);

	// Start searching for files in the current directory. 

	hSearch = FindFirstFile(extensionToBack, &FileData); 
	if (hSearch == INVALID_HANDLE_VALUE) 
	{ 
		error = TRUE;
	} 

	// Copy each file to the new directory 
	CString str;
	while (!fFinished && !error) 
	{ 
		lstrcpy(szNewPath, szDirPath); 
		lstrcat(szNewPath, FileData.cFileName); 

		if(PathFileExists(szNewPath))
		{
			if (conFirm)
			{
				if (y2All == FALSE)
				{
					_stprintf(buffer, _T("File %s Already Exists. OverWrite It?"), FileData.cFileName);
					int rc = ::XMessageBox(m_hWnd,buffer,_T("OverWrite?"),MB_YESNO|MB_YESTOALL|MB_ICONQUESTION);
					if (rc == IDYES)
						OverWrite = TRUE;
					else if (rc == IDYESTOALL)
					{
						OverWrite = TRUE;
						y2All = TRUE;
					}
					else 
						OverWrite = FALSE;
				} else
					OverWrite = TRUE;
			} 
			else
				OverWrite = TRUE;
		}	
		if(OverWrite)
			CopyFile(FileData.cFileName, szNewPath, FALSE);

		if (!FindNextFile(hSearch, &FileData)) 
		{
			if (GetLastError() == ERROR_NO_MORE_FILES) 
			{ 
				//MessageBox("File Copied Successfully.", "BackUp complete", MB_OK); 
				fFinished = TRUE; 

			} 
			else 
			{ 
				error = TRUE;
			} 
		}

	} 


	// Close the search handle. 
	if (!FindClose(hSearch)) 
	{ 
		error = TRUE;
	} 
	if (error)
		MessageBox(_T("Error encountered during backup"),_T("Error"),MB_OK);
}


void CPPgIonixMisc::Backup2(LPCTSTR extensionToBack)  
{

	WIN32_FIND_DATA FileData;   
	HANDLE hSearch;   
	TCHAR buffer[200];  


	//CString szDirPath = CString(thePrefs.GetAppDir());  
	CString szDirPath = CString(thePrefs.GetConfigDir());
	CString szTempPath = CString(thePrefs.GetTempDir());  
	TCHAR szNewPath[MAX_PATH]; 

	BOOL fFinished = FALSE;     
	BOOL error = FALSE;  
	BOOL OverWrite = TRUE;  
	szDirPath +="Backup\\";

	if(!PathFileExists(szDirPath))  
		CreateDirectory(szDirPath, NULL);  

	szDirPath+="temp\\";  

	if(!PathFileExists(szDirPath))  
		CreateDirectory(szDirPath, NULL);  


	// Start searching for files in the current directory.   
	SetCurrentDirectory(szTempPath);  

	hSearch = FindFirstFile(extensionToBack, &FileData);   

	if (hSearch == INVALID_HANDLE_VALUE)   
	{   
		error = TRUE;
	}   

	// Copy each file to the new directory   
	while (!fFinished && !error)   
	{   
		lstrcpy(szNewPath, szDirPath);   
		lstrcat(szNewPath, FileData.cFileName);   

		//MessageBox(szNewPath,"New Path",MB_OK);  
		if(PathFileExists(szNewPath))  
		{  
			if (y2All == FALSE)
			{
				_stprintf(buffer, _T("File %s Already Exists. OverWrite It?"), FileData.cFileName);
				int rc = ::MessageBox(m_hWnd,buffer,_T("OverWrite?"),MB_YESNO|MB_YESTOALL|MB_ICONQUESTION);
				if (rc == IDYES)
					OverWrite = TRUE;
				else if (rc == IDYESTOALL)
				{
					OverWrite = TRUE;
					y2All = TRUE;
				}
				else 
					OverWrite = FALSE;
			} else
				OverWrite = TRUE;  
		}  

		if(OverWrite)  
			CopyFile(FileData.cFileName, szNewPath, FALSE);  

		if (!FindNextFile(hSearch, &FileData))   
		{  
			if (GetLastError() == ERROR_NO_MORE_FILES)   
			{   

				fFinished = TRUE;   
			}   
			else   
			{   
				error = TRUE;  
			}   
		}  

	}   

	// Close the search handle.   
	if (!FindClose(hSearch))   
	{   
		error = TRUE;  
	}   
	SetCurrentDirectory(CString(thePrefs.GetConfigDir()));  

	if (error)  
		MessageBox(_T("Error encountered during backup"),_T("Error"),MB_OK);  

} 

void CPPgIonixMisc::OnBnClickedSelectall()
{
	CheckDlgButton(IDC_DAT,BST_CHECKED);
	CheckDlgButton(IDC_MET,BST_CHECKED);
	CheckDlgButton(IDC_INI,BST_CHECKED);
	CheckDlgButton(IDC_PART,BST_CHECKED);
	CheckDlgButton(IDC_PARTMET,BST_CHECKED);
	GetDlgItem(IDC_BACKUPNOW)->EnableWindow(true);
}

void CPPgIonixMisc::Backup3()
{
	WIN32_FIND_DATA FileData; 
	HANDLE hSearch; 
	CString szDirPath = CString(thePrefs.GetConfigDir())+_T("Backup\\");
	if(!PathFileExists(szDirPath)) return;
	TCHAR szNewPath[MAX_PATH]; 

	SetCurrentDirectory(szDirPath);
	BOOL error = FALSE;
	szDirPath = CString(thePrefs.GetConfigDir())+_T("Backup2\\");

	BOOL fFinished = FALSE; 

	// Create a new directory if one does not exist
	if(!PathFileExists(szDirPath))
		CreateDirectory(szDirPath, NULL);

	// Start searching for files in the current directory. 

	hSearch = FindFirstFile(_T("*.*"), &FileData); 
	if (hSearch == INVALID_HANDLE_VALUE) 
	{ 
		error = TRUE;
	} 

	// Copy each file to the new directory 
	while (!fFinished && !error) 
	{ 
		lstrcpy(szNewPath, szDirPath); 
		lstrcat(szNewPath, FileData.cFileName); 

		CopyFile(FileData.cFileName, szNewPath, FALSE);

		if (!FindNextFile(hSearch, &FileData)) 
		{
			if (GetLastError() == ERROR_NO_MORE_FILES) 
			{ 
				//MessageBox("File Copied Successfully.", "BackUp complete", MB_OK); 
				fFinished = TRUE; 

			} 
			else 
			{ 
				error = TRUE;
			} 
		}

	} 

	// Close the search handle. 
	if (!FindClose(hSearch)) 
	{ 
		error = TRUE;
	} 
	if (error)
		MessageBox(_T("Error encountered during backup"),_T("Error"),MB_OK);
}

void CPPgIonixMisc::OnBnClickedusesls()
{
	if(IsDlgButtonChecked(IDC_SLS_USESLS))
	{
		GetDlgItem(IDC_SLS_NUMBER)->EnableWindow(true);
		GetDlgItem(IDC_SLS_LIMIT)->EnableWindow(true);
	}
	else
	{
		GetDlgItem(IDC_SLS_NUMBER)->EnableWindow(false);
		GetDlgItem(IDC_SLS_LIMIT)->EnableWindow(false);
	}
	SetModified();
}

//>>> [ionix] - ionixguide
void CPPgIonixMisc::OnHelp()
{
	theApp.ShowIonixHelp();
}

BOOL CPPgIonixMisc::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if (wParam == ID_HELP)
	{
		OnHelp();
		return TRUE;
	}
	return __super::OnCommand(wParam, lParam);
}

BOOL CPPgIonixMisc::OnHelpInfo(HELPINFO* pHelpInfo)
{
	OnHelp();
	return TRUE;
}
//<<< [ionix] - ionixguide