// PPgIonixShare.cpp : implementation file
#include "stdafx.h"
#include "emule.h"
#include "PPgIonixShare.h"
#include "OtherFunctions.h"
#include "Preferences.h"
#include "UserMsgs.h"
//EastShare Start - added by [ionix], IP to Country
#include "ip2country.h"
//EastShare End - added by [ionix], IP to Country
// [ionix] - ProgressBars
#include "eMuleDlg.h"
#include "TransferWnd.h"
// [ionix] - ProgressBars
#include "./AntiLeech/PPgAntiLeech.h" //>>> [ionix] - LeecherBox
#include "SharedFileList.h" // Morph: PowerShare

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#endif

// CPPgIonixShare dialog

IMPLEMENT_DYNAMIC(CPPgIonixShare, CPropertyPage)
CPPgIonixShare::CPPgIonixShare()
	: CPropertyPage(CPPgIonixShare::IDD)
	, m_ctrlTreeOptions(theApp.m_iDfltImageListColorFlags)	
{
	m_bInitializedTreeOpts = false;
	m_htiDM = NULL;

	// CreditSystem
	m_htiCreditSystem = NULL;
	m_htiOfficialCredit = NULL;
	m_htiLovelaceCredit = NULL;
	m_htiPawcioCredit = NULL;
	m_htiPawcio2Credit = NULL; // optimized for FullChunks
	m_htiFullChunksCredit = NULL; // by Wiz
	m_htiCreditsNoneStatic = NULL;
	// CreditSystem

	m_htiDlSecu = NULL;

	// Sivka - Aggressive Client Handling
	m_htiSivkaAskTime = NULL;
	m_htiSivkaAskCounter = NULL;
	m_htiSivkaAskLog = NULL;
	// Sivka - Aggressive Client Handling

	// Morph: PowerShare
	m_htiUM = NULL;
	m_htiSFM = NULL;
	m_htiHideOS = NULL;	//MORPH - Added by [ionix], SLUGFILLER: hideOS
	m_htiSelectiveShare = NULL;	//MORPH - Added by [ionix], SLUGFILLER: hideOS
	m_htiShareOnlyTheNeed = NULL; //MORPH - Added by [ionix], SHARE_ONLY_THE_NEED
	m_iHideOS = 0;
	m_bSelectiveShare = false;
	m_bShareOnlyTheNeed = false;
	// <--- Morph: PowerShare
}

void CPPgIonixShare::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EXT_OPTS, m_ctrlTreeOptions);
	if ( !m_bInitializedTreeOpts )
	{
		int iImgDM = 8; // default icon
		int iImgSecu = 8; // default icon
		int iImgCS = 8; // default icon
		// Morph: PowerShare
		int iImgUM = 8;
		int iImgSFM = 8;
		// <--- Morph: PowerShare
		CImageList* piml = m_ctrlTreeOptions.GetImageList(TVSIL_NORMAL);
		if (piml){
			iImgDM = piml->Add(CTempIconLoader(_T("DOWNLOAD")));
			iImgSecu = piml->Add(CTempIconLoader(_T("SECURITY")));
			iImgCS = piml->Add(CTempIconLoader(_T("STATSCLIENTS"))); // CreditSystem
			// Morph: PowerShare
			iImgUM = piml->Add(CTempIconLoader(_T("Upload")));
			iImgSFM = piml->Add(CTempIconLoader(_T("Sharedfiles")));
			// <--- Morph: PowerShare
		}

		CString Buffer;
		m_htiDM = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_DM), iImgDM, TVI_ROOT);

		m_htiDlSecu = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_SECURITY), iImgSecu, m_htiDM);

		// Sivka - Aggressive Client Handling
		m_htiSivkaAskTime = m_ctrlTreeOptions.InsertItem(GetResString(IDS_SIVKA_ASK_TIME), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiDlSecu);
		m_ctrlTreeOptions.AddEditBox(m_htiSivkaAskTime, RUNTIME_CLASS(CNumTreeOptionsEdit));
		m_htiSivkaAskCounter = m_ctrlTreeOptions.InsertItem(GetResString(IDS_SIVKA_ASK_COUNTER), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiDlSecu);
		m_ctrlTreeOptions.AddEditBox(m_htiSivkaAskCounter, RUNTIME_CLASS(CNumTreeOptionsEdit));
		m_htiSivkaAskLog = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_SIVKA_ASK_LOG), m_htiDlSecu, m_bSivkaAskLog);
		// Sivka - Aggressive Client Handling

		// Creditsystem  
		m_htiCreditSystem = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_CREDIT_SYSTEM), iImgCS, TVI_ROOT);
		//m_htiOfficialCredit = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_OFFICIAL_CREDIT), m_htiCreditSystem, m_iCreditSystem == 0);
		//m_htiLovelaceCredit = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_LOVELACE_CREDIT), m_htiCreditSystem, m_iCreditSystem == 1);
		//m_htiPawcioCredit = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_PAWCIO_CREDIT), m_htiCreditSystem, m_iCreditSystem == 2);
		//m_htiCreditsNoneStatic = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_CREDITS_NONE), m_htiCreditSystem, m_iCreditSystem == 3);
		m_htiOfficialCredit = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_OFFICIAL_CREDIT), m_htiCreditSystem, IDC_IONIX_OFFICIAL_CREDIT == 0);
		m_htiLovelaceCredit = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_LOVELACE_CREDIT), m_htiCreditSystem, IDC_IONIX_LOVELACE_CREDIT == 1);
		m_htiPawcioCredit = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_PAWCIO_CREDIT), m_htiCreditSystem, IDC_IONIX_PAWCIO_CREDIT == 2);
		m_htiPawcio2Credit = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_PAWCIO_CREDIT), m_htiCreditSystem, IDC_IONIX_PAWCIO2_CREDIT == 3); // optimized for FullChunks
		m_htiFullChunksCredit = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_PAWCIO_CREDIT), m_htiCreditSystem, IDC_IONIX_FULLCHUNKS_CREDIT == 4); // by Wiz
		m_htiCreditsNoneStatic = m_ctrlTreeOptions.InsertRadioButton(GetResString(IDS_CREDITS_NONE), m_htiCreditSystem, IDC_IONIX_NONE_CREDIT == 5);
		// CreditSystem

		// Morph: PowerShare
		m_htiUM = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_UM), iImgUM, TVI_ROOT);
		m_htiHideOS = m_ctrlTreeOptions.InsertItem(GetResString(IDS_HIDEOVERSHARES), TREEOPTSCTRLIMG_EDIT, TREEOPTSCTRLIMG_EDIT, m_htiUM);
		m_ctrlTreeOptions.AddEditBox(m_htiHideOS, RUNTIME_CLASS(CNumTreeOptionsEdit));
		m_htiSelectiveShare = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_SELECTIVESHARE), m_htiHideOS, m_bSelectiveShare);
		m_htiSFM = m_ctrlTreeOptions.InsertGroup(GetResString(IDS_SFM), iImgSFM, TVI_ROOT);
		m_htiShareOnlyTheNeed = m_ctrlTreeOptions.InsertCheckBox(GetResString(IDS_SHAREONLYTHENEED), m_htiSFM, m_bShareOnlyTheNeed);
		m_ctrlTreeOptions.Expand(m_htiUM, TVE_EXPAND);
		m_ctrlTreeOptions.Expand(m_htiSFM, TVE_EXPAND);
		m_ctrlTreeOptions.Expand(m_htiHideOS, TVE_EXPAND);
		// <--- Morph: PowerShare

		m_ctrlTreeOptions.Expand(m_htiDlSecu, TVE_EXPAND);	//Security
		m_ctrlTreeOptions.Expand(m_htiCreditSystem, TVE_EXPAND);	// CreditSystem

		m_ctrlTreeOptions.Expand(m_htiDM, TVE_EXPAND);

		m_ctrlTreeOptions.SelectItem(m_ctrlTreeOptions.GetRootItem());
		m_bInitializedTreeOpts = true;
	}

	DDX_TreeRadio(pDX, IDC_EXT_OPTS, m_htiCreditSystem, (int &)m_iCreditSystem); // CreditSystem

	// Sivka - Aggressive Client Handling
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiSivkaAskTime, m_iSivkaAskTime);
	DDV_MinMaxInt(pDX, m_iSivkaAskTime, 5, 12);
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiSivkaAskCounter, m_iSivkaAskCounter);
	DDV_MinMaxInt(pDX, m_iSivkaAskCounter, 4, 25);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiSivkaAskLog, m_bSivkaAskLog);
	// Sivka - Aggressive Client Handling

	// Morph: PowerShare
	DDX_TreeEdit(pDX, IDC_EXT_OPTS, m_htiHideOS, m_iHideOS);
	DDV_MinMaxInt(pDX, m_iHideOS, 0, INT_MAX);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiSelectiveShare, m_bSelectiveShare);
	DDX_TreeCheck(pDX, IDC_EXT_OPTS, m_htiShareOnlyTheNeed, m_bShareOnlyTheNeed);
	// <--- Morph: PowerShare
}

BEGIN_MESSAGE_MAP(CPPgIonixShare, CPropertyPage)
	ON_BN_CLICKED(IDC_ANTINICKTHIEF, OnSettingsChange) 	// AntiNickThief 
	ON_EN_CHANGE(IDC_IsClientBanTime, OnSettingsChange) // AntiNickThief
	ON_BN_CLICKED(IDC_ANTIMODIDFAKER, OnSettingsChange) // Anti Mod Faker Version
	ON_BN_CLICKED(IDC_ANTILEECHERMOD, OnSettingsChange) // AntiLeecher
	ON_BN_CLICKED(IDC_SHOWLEECHERBOX, OnBnClickedLeecherBox) // [ionix] - LeecherBox
	ON_BN_CLICKED(IDC_SNAFU, OnSettingsChange) // SNAFU_V3
	ON_BN_CLICKED(IDC_LEECHERSECURELOG, OnSettingsChange) // LeecherSecureLog
	ON_MESSAGE(UM_TREEOPTSCTRL_NOTIFY, OnTreeOptsCtrlNotify)
	ON_WM_HELPINFO() //<<< [ionix] - ionixguide
	ON_WM_DESTROY()
END_MESSAGE_MAP()

BOOL CPPgIonixShare::OnInitDialog()
{
	((CEdit*)GetDlgItem(IDC_IsClientBanTime))->SetLimitText(2); // AntiNickThief - feldgre auf 2 zeichen begrenzen

	// Sivka - Aggressive Client Handling
	m_iSivkaAskTime = (int)(thePrefs.GetSivkaAskTime());
	m_iSivkaAskCounter = (int)(thePrefs.GetSivkaAskCounter());
	m_bSivkaAskLog = thePrefs.GetSivkaAskLog();
	// Sivka - Aggressive Client Handling

	m_iCreditSystem = thePrefs.GetCreditSystem(); // CreditSystem 

	// Morph: PowerShare
	m_iHideOS = thePrefs.hideOS; //MORPH - Added by [ionix], SLUGFILLER: hideOS
	m_bSelectiveShare = thePrefs.selectiveShare; //MORPH - Added by [ionix], SLUGFILLER: hideOS
	m_bShareOnlyTheNeed = thePrefs.ShareOnlyTheNeed; //MORPH - Added by [ionix], SHARE_ONLY_THE_NEED
	// <--- Morph: PowerShare

	CPropertyPage::OnInitDialog();
	InitWindowStyles(this);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgIonixShare::LoadSettings(void)
{
	if(m_hWnd)
	{
		CString strBuffer;

		// AntiNickThief
		GetDlgItem(IDC_IsClientBanTime)->EnableWindow(true); 
		strBuffer.Format(_T("%d"), thePrefs.GetClientBanTime()); 
		GetDlgItem(IDC_IsClientBanTime)->SetWindowText(strBuffer);  
		CheckDlgButton(IDC_ANTINICKTHIEF, thePrefs.GetAntiNickThief());
		// AntiNickThief 

		// Anti Mod Faker Version
		CheckDlgButton(IDC_ANTIMODIDFAKER, thePrefs.IsAntiModIdFaker());
		// Anti Mod Faker Version

		// AntiLeecher 
		CheckDlgButton(IDC_ANTILEECHERMOD, thePrefs.IsLeecherSecure());
		// AntiLeecher 

		// eWombat SNAFU_V3
		CheckDlgButton(IDC_SNAFU, thePrefs.GetAntiSnafu());
		// eWombat SNAFU_V3

		// LeecherSecureLog 
		CheckDlgButton(IDC_LEECHERSECURELOG, thePrefs.IsLeecherSecureLog());
		// LeecherSecureLog 
	}
}

BOOL CPPgIonixShare::OnApply()
{
	CString sBuffer;

	// AntiNickThief
	GetDlgItem(IDC_IsClientBanTime)->GetWindowText(sBuffer); 
	thePrefs.SetClientBanTime(_tstoi(sBuffer)?min(_tstoi(sBuffer), 20):4);
	thePrefs.m_bAntiNickThief = IsDlgButtonChecked(IDC_ANTINICKTHIEF)!=0;
	// AntiNickThief

	// Anti Mod Faker Version 
	thePrefs.m_bAntiModIdFaker = IsDlgButtonChecked(IDC_ANTIMODIDFAKER)!=0;
	// Anti Mod Faker Version

	// AntiLeecher
	thePrefs.m_bAntiLeecherMod = IsDlgButtonChecked(IDC_ANTILEECHERMOD)!=0;
	// AntiLeecher

	// eWombat SNAFU_V3
	thePrefs.m_bSnafu = IsDlgButtonChecked(IDC_SNAFU)!=0;
	// eWombat SNAFU_V3

	// LeecherSecureLog 
	thePrefs.m_bLeecherSecureLog = IsDlgButtonChecked(IDC_LEECHERSECURELOG)!=0;
	// LeecherSecureLog 

	m_ctrlTreeOptions.HandleChildControlLosingFocus();

	if (!UpdateData())
		return FALSE;

	// Sivka - Aggressive Client Handling
	thePrefs.SetSivkaAskTime(m_iSivkaAskTime);
	thePrefs.SetSivkaAskCounter(m_iSivkaAskCounter);
	thePrefs.SetSivkaAskLog(m_bSivkaAskLog);
	// Sivka - Aggressive Client Handling

	thePrefs.SetCreditSystem(m_iCreditSystem); // CreditSystem

	// Morph: PowerShare
	thePrefs.hideOS = m_iHideOS;	//MORPH - Added by [ionix], SLUGFILLER: hideOS
	thePrefs.selectiveShare = m_bSelectiveShare; //MORPH - Added by [ionix], SLUGFILLER: hideOS
	thePrefs.ShareOnlyTheNeed = m_bShareOnlyTheNeed; //MORPH - Added by [ionix], SHARE_ONLY_THE_NEED
	// <--- Morph: PowerShare

	SetModified(FALSE);

	LoadSettings();
	return CPropertyPage::OnApply();
}

void CPPgIonixShare::Localize(void)
{
	if ( m_hWnd )
	{
		GetDlgItem(IDC_ANTINICKTHIEF)->SetWindowText(GetResString(IDS_ANTINICKTHIEF));
		GetDlgItem(IDC_ANTILEECHERGROUPBOX)->SetWindowText(GetResString(IDS_ANTILEECHERGROUPBOX));
		GetDlgItem(IDC_IsClientBanTime_static)->SetWindowText(GetResString(IDS_IsClientBanTime_static));
		GetDlgItem(IDC_LEECHERSECURELOG)->SetWindowText(GetResString(IDS_LEECHERSECURELOG));
		GetDlgItem(IDC_ANTIMODIDFAKER)->SetWindowText(GetResString(IDS_ANTIMODIDFAKER));
		GetDlgItem(IDC_ANTILEECHERMOD)->SetWindowText(GetResString(IDS_ANTILEECHERMOD));
		GetDlgItem(IDC_SNAFU)->SetWindowText(GetResString(IDS_SNAFU));
		GetDlgItem(IDC_SHOWLEECHERBOX)->SetWindowText(GetResString(IDS_LEECHERBOX)); // [ionix] - LeecherBox

		if (m_htiDM) m_ctrlTreeOptions.SetItemText(m_htiDM, GetResString(IDS_DM));
		if (m_htiDlSecu) m_ctrlTreeOptions.SetItemText(m_htiDlSecu, GetResString(IDS_SECURITY));

		// Sivka - Aggressive Client Handling
		if (m_htiSivkaAskTime) m_ctrlTreeOptions.SetEditLabel(m_htiSivkaAskTime, GetResString(IDS_SIVKA_ASK_TIME));
		if (m_htiSivkaAskCounter) m_ctrlTreeOptions.SetEditLabel(m_htiSivkaAskCounter, GetResString(IDS_SIVKA_ASK_COUNTER));
		if (m_htiSivkaAskLog) m_ctrlTreeOptions.SetItemText(m_htiSivkaAskLog, GetResString(IDS_SIVKA_ASK_LOG));
		// Sivka - Aggressive Client Handling

		// Creditsystem  
		if (m_htiCreditSystem) m_ctrlTreeOptions.SetItemText(m_htiCreditSystem, GetResString(IDS_CREDIT_SYSTEM));
		if (m_htiOfficialCredit) m_ctrlTreeOptions.SetItemText(m_htiOfficialCredit, GetResString(IDS_OFFICIAL_CREDIT));
		if (m_htiLovelaceCredit) m_ctrlTreeOptions.SetItemText(m_htiLovelaceCredit, GetResString(IDS_LOVELACE_CREDIT));
		if (m_htiPawcioCredit) m_ctrlTreeOptions.SetItemText(m_htiPawcioCredit, GetResString(IDS_PAWCIO_CREDIT));
		if (m_htiPawcio2Credit) m_ctrlTreeOptions.SetItemText(m_htiPawcio2Credit, _T("Pawcio modified"));
		if (m_htiFullChunksCredit) m_ctrlTreeOptions.SetItemText(m_htiFullChunksCredit, _T("ChunkZ"));
		if (m_htiCreditsNoneStatic) m_ctrlTreeOptions.SetItemText(m_htiCreditsNoneStatic, GetResString(IDS_CREDITS_NONE));
		// CreditSystem

		// Morph: PowerShare
		if (m_htiHideOS) m_ctrlTreeOptions.SetEditLabel(m_htiHideOS, GetResString(IDS_HIDEOVERSHARES));//MORPH - Added by [ionix], SLUGFILLER: hideOS
		if (m_htiSelectiveShare) m_ctrlTreeOptions.SetItemText(m_htiSelectiveShare, GetResString(IDS_SELECTIVESHARE));//MORPH - Added by [ionix], SLUGFILLER: hideOS
		if (m_htiShareOnlyTheNeed) m_ctrlTreeOptions.SetItemText(m_htiShareOnlyTheNeed, GetResString(IDS_SHAREONLYTHENEED));//MORPH - Added by [ionix], SHARE_ONLY_THE_NEED
		// <--- Morph: PowerShare
	}
}

void CPPgIonixShare::OnDestroy()
{
	m_ctrlTreeOptions.DeleteAllItems();
	m_ctrlTreeOptions.DestroyWindow();
	m_bInitializedTreeOpts = false;

	m_htiDM = NULL;

	m_htiDlSecu = NULL;

	// Sivka - Aggressive Client Handling
	m_htiSivkaAskTime = NULL;
	m_htiSivkaAskCounter = NULL;
	m_htiSivkaAskLog = NULL;
	// Sivka - Aggressive Client Handling

	// CreditSystem
	m_htiCreditSystem = NULL;
	m_htiOfficialCredit = NULL;
	m_htiLovelaceCredit = NULL;
	m_htiPawcioCredit = NULL;
	m_htiPawcio2Credit = NULL; // optimized for FullChunks
	m_htiFullChunksCredit = NULL; // by Wiz
	m_htiCreditsNoneStatic = NULL;
	// CreditSystem

	// Morph: PowerShare
	m_htiUM = NULL;
	m_htiSFM = NULL;
	m_htiHideOS = NULL;	//MORPH - Added by [ionix], SLUGFILLER: hideOS
	m_htiSelectiveShare = NULL;	//MORPH - Added by [ionix], SLUGFILLER: hideOS
	m_htiShareOnlyTheNeed = NULL; //MORPH - Added by [ionix], SHARE_ONLY_THE_NEED
	// Morph: PowerShare

	CPropertyPage::OnDestroy();
}

BOOL CPPgIonixShare::OnKillActive()
{
	// if prop page is closed by pressing VK_ENTER we have to explicitly commit any possibly pending
	// data from an open edit control
	m_ctrlTreeOptions.HandleChildControlLosingFocus();
	return CPropertyPage::OnKillActive();
}

LRESULT CPPgIonixShare::OnTreeOptsCtrlNotify(WPARAM wParam, LPARAM lParam)
{
	if (wParam == IDC_EXT_OPTS)
		SetModified();
	return 0;
}

//>>> [ionix] - LeecherBox
void CPPgIonixShare::OnBnClickedLeecherBox()
{
	CPPgAntiLeech dialog;
	dialog.DoModal();
}
//<<< [ionix] - LeecherBox

CPPgIonixShare::~CPPgIonixShare(void)
{
}

//>>> [ionix] - ionixguide
void CPPgIonixShare::OnHelp()
{
	theApp.ShowIonixHelp();
}

BOOL CPPgIonixShare::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if (wParam == ID_HELP)
	{
		OnHelp();
		return TRUE;
	}
	return __super::OnCommand(wParam, lParam);
}

BOOL CPPgIonixShare::OnHelpInfo(HELPINFO* pHelpInfo)
{
	OnHelp();
	return TRUE;
}
//<<< [ionix] - ionixguide