#pragma once
#include "PPgGeneral.h"
#include "PPgConnection.h"
#include "PPgIonixDynUpload.h" //Pawcio: BC // [ionix] - changed: was PPgBandwidthControl
#include "PPgServer.h"
#include "PPgDirectories.h"
#include "PPgFiles.h"
#include "PPgStats.h"
#include "PPgNotify.h"
#include "PPgIRC.h"
#include "PPgTweaks.h"
#include "PPgDisplay.h"
#include "PPgSecurity.h"
#include "PPgWebServer.h"
#include "PPgScheduler.h"
#include "PPgProxy.h"
#include "TreePropSheet.h"
//>>> [ionix] - Prefs
#include "PPgIonixConnect.h"
#include "PPgIonixShare.h"
#include "PPgIonixDown.h"
#include "PPgIonixLF.h"
#include "PPgIonixMisc.h"
#include "PPgIonixUpdate.h"
#include "PPgIonixWebServer.h"
//<<< [ionix] - Prefs
#include "./WebCache/PPgWebcachesettings.h" // WebCache: jp
//#include "./AntiLeech/PPgAntiLeech.h" //>>> AntiLeech Class
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
#include "PPgDebug.h"
#endif
#include "otherfunctions.h"
#include "TreePropSheet.h"
//#include "ListBoxST.h"
#include "KCSideBannerWnd.h" 	// [TPT] - New Preferences Banner	

class CPreferencesDlg : public CTreePropSheet
{
	DECLARE_DYNAMIC(CPreferencesDlg)

public:
	CPreferencesDlg();
	virtual ~CPreferencesDlg();
	
	CPPgGeneral		m_wndGeneral;
	CPPgConnection	m_wndConnection;
	CPPgIonixDynUpload	m_wndBC; //Pawcio: BC // [ionix] - changed: was PPgBandwidthControl
	CPPgServer		m_wndServer;
	CPPgDirectories	m_wndDirectories;
	CPPgFiles		m_wndFiles;
	CPPgStats		m_wndStats;
	CPPgNotify		m_wndNotify;
	CPPgIRC			m_wndIRC;
	CPPgTweaks		m_wndTweaks;
	CPPgDisplay		m_wndDisplay;
	CPPgSecurity	m_wndSecurity;
	CPPgWebServer	m_wndWebServer;
	CPPgScheduler	m_wndScheduler;
	CPPgProxy		m_wndProxy;
	//>>> [ionix] - Prefs
	CPPgIonixConnect	m_wndIonixConnect;
	CPPgIonixShare		m_wndIonixShare;
	CPPgIonixDown		m_wndIonixDown;
	CPPgIonixLF			m_wndIonixLF;
	CPPgIonixMisc		m_wndIonixMisc;
	CPPgIonixUpdate		m_wndIonixUpdate;
	CPPgIonixWebServer	m_wndIonixWebServer;
	//<<< [ionix] - Prefs
	CPPgWebcachesettings	m_wndWebcachesettings; // WebCache: jp
#if defined(_DEBUG) || defined(USE_DEBUG_DEVICE)
	CPPgDebug		m_wndDebug;
#endif
	//CPPgAntiLeech	m_wndAntiLeech; //>>> AntiLeech Class

	void Localize();
	void SetStartPage(UINT uStartPageID);
	void UpdateBCStatus();//Pawcio: BC

protected:
	LPCTSTR m_pPshStartPage;
	bool m_bSaveIniFile;

	virtual BOOL OnInitDialog();
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);

	DECLARE_MESSAGE_MAP()
	afx_msg void OnDestroy();
	afx_msg void OnHelp();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
protected:
	CKCSideBannerWnd m_banner;	// [TPT] - New Preferences Banner
};
